# Is the version number for blocks+ the same as for blocks?  Or use the date?

import Martel
from Martel import RecordReader

import blocks_12 as blocks

date = Martel.Group("date",
                    Martel.Re(r"(?P<day>\d+) (?P<month>\w+) (?P<year>\d+)"))
header = Martel.Re(r" *Blocks\+ Database, ") + date + Martel.AnyEol() + \
         Martel.Rep(Martel.Re(r"(?!ID)[^\R]*\R"))

ID_line = blocks.ID_line
AC_line = blocks.AC_line
DE_line = blocks.DE_line
data_line = blocks.data_line

# Allow multiple blank lines, and terminal blank ones.
# (Not needed in blocks - only blocks+ (?))
cluster = Martel.Group("cluster",
                       Martel.Rep1(data_line) + \
                       Martel.Rep(Martel.Rep1(blocks.blank_line) + \
                                  Martel.Rep(data_line)))
end_line = blocks.end_line

# Can't use the blocks BL_line definition because the name can be
# 'adapted' and because the number of spaces between the name and
# 'width=' can be varied.
BL_line = Martel.Str("BL   ") + \
          blocks.UpTo(";", "name") + \
          Martel.Re("; *") + \
          blocks.BL_data + Martel.Re(r" *\R") 

record = Martel.Group("blocksplus_record",
                      ID_line + \
                      AC_line + \
                      DE_line + \
                      BL_line + \
                      cluster + \
                      end_line)

format = Martel.HeaderFooter("blocksplus",
                             header, RecordReader.Until, ("ID",),
                             record, RecordReader.EndsWith, ("//",),
                             None, None, None,
                             )
