from Martel.formats.MDL_10_1996 import *

import support

test_list = support.Storage()
add_test = test_list.add_test
add_test_lines = test_list.add_test_lines

# Examples come from Accord 3.4 Examples/Ctable

add_test_lines("counts_line", counts_line, """\
  5  4  0  0  0  0  0  0  0  0  1 V2000
  2  1  0  0  0  0              1 V2000
""")

add_test_lines("atom_line", atom_line, """\
   -8.5645    1.3065    0.0000 C  
   -0.5037    0.4583    0.0000 O   0  5
    0.1215   -0.1492    0.1066 He  0  0  0  0  0  0
    0.8472   -2.9382    0.0000 C   1  2  3  4  5  6  7  8  9  1  2  3
""")

add_test_lines("bond_line", bond_line, """\
  1  4  1
  2  4  1
 19  4  1  6
  1  2  2  0  0  0
  1  2  2  3  0  1 -1
""")

add_test("atom_list", atom_list, """\
  2 F    2  17  35
""")
add_test_lines("charge", charge, """\
M  CHG  1   1   2
M  CHG  4  22  -1  47   1  69  -1 114   1
M  CHG  2   2  -1   4   1
""")

add_test_lines("radical", radical, """\
M  RAD  1   8   2
M  RAD  8   1   2   2   2   3   2   5   2   8   2  10   2  11   2  14   2
""")

add_test("isotope", isotope, """\
M  ISO  2   2  16   3  14
""")

add_test("group_abbreviation", atom_group, """\
G   17  0
HCl
""")

add_test("sgroup_type", sgroup_type, """\
M  STY  1   1 SUP
""")

add_test("sgroup_labels", sgroup_labels, """\
M  SLB  1   1   1
""")

add_test("sgroup_atom_list", sgroup_atom_list, """\
M  SAL   1  1  17
""")

add_test("sgroup_subscript", sgroup_subscript, """\
M  SMT   1 HCl
""")

add_test("M_atom_list", M_atom_list, """\
M  ALS   2  2 F Na  Cl
""")

add_test("$3D, type -1", x3D_feature_point_dist, """\
M  $3D -1  4 POINT_1
M  $3D  1  3    2.0000
""")

# made up test
add_test("$3D, type -2", x3D_feature_point_frac, """\
M  $3D -2  4 POINT_2
M  $3D  1  3    0.6125
""")

# made up test
add_test("$3D, type -3", x3D_feature_point_normal, """\
M  $3D -3  6
M  $3D  9 11   -2.0000
""")

add_test("$3D, type -4, 1", x3D_feature_best_fit, """\
M  $3D -4  2 N_TO_AROM
M  $3D  4    1.2000
M  $3D  1 14 15 19
""")

# made up test
add_test("$3D, type -4, 2", x3D_feature_best_fit, """\
M  $3D -4  9 SINGLE
M  $3D  1    0.2000
M  $3D 32
""")

# made up test
add_test("$3D, type -4, 3", x3D_feature_best_fit, """\
M  $3D -4  0 MANY_ATOMS
M  $3D 24    0.2000
M  $3D  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20
M  $3D 21 22 23
M  $3D 24
""")

# Documentation example doesn't list the deviation; is it optional?
# It also only has a single space betwen the "1" and "5" of the 3rd
# line, so I think the doc is buggy.
add_test("$3D, type -5, 1", x3D_feature_plane_points, """\
M  $3D -5  4 PLANE_2
M  $3D  3    2.1000
M  $3D  1  5 14
""")

# made up test
add_test("$3D, type -5, 2", x3D_feature_plane_points, """\
M  $3D -5  4 PLANE_AIR
M  $3D 21    9.8010
M  $3D  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20
M  $3D100
""")

add_test("$3D, type -6", x3D_feature_plane_point_line, """\
M  $3D -6  3 PLANE_1
M  $3D  1 16
""")

example_molfile = """\

  Accord  0625971532

  7  6  0  0  0  0  0  0  0  0  2 V2000
    2.6583   -1.4125    0.0000 C  
    2.6583   -2.1667    0.0000 C  
    3.3079   -2.5417    0.0000 N   0  5
    3.9615   -2.1667    0.0000 C  
    3.9615   -1.4125    0.0000 C  
    3.3079   -1.0333    0.0000 O  
    3.3083   -3.5292    0.0000 Li  0  3
  1  6  1
  1  2  1
  2  3  1
  3  4  1
  4  5  1
  5  6  1
M  CHG  2   3  -1   7   1
M  END
"""

example_molfile2 = """\

  -ISIS-  12099811342D

  2  1  1  0  0  0  0  0  0  0999 V2000
    0.1234   -1.6789    0.0000 C   0  0  0  0  0  0  0  0  0  1  0  0
    1.8765   -0.6644    0.0000 L   0  0  0  0  0  0  0  0  0  0  0  0
  1  2  1  0  0  0  0
  2 F    2  17  35
M  ALS   2  2 F Cl  Br  
M  END
"""

add_test("Mol format", molfile_format, example_molfile)

example_rxnfile_header = """\
$RXN

      ISIS     110119991234

  1  1
"""

example_rxnfile = example_rxnfile_header + \
                  "$MOL\n" + example_molfile + \
                  "$MOL\n" + example_molfile2

add_test("Rxn header", rxn_header, example_rxnfile_header)
add_test("Rxn format", rxnfile_format, example_rxnfile)

# Notice the spaces at the end the second line!
add_test_lines("molecule identifier", 
         rdfile_midentifier1 | rdfile_midentifier2 | rdfile_midentifier3, """\
$MFMT $MIREG 123456
$MFMT $MIREG 52001                                                              
""")
add_test("reaction identifier", 
         rdfile_ridentifier1 | rdfile_ridentifier3 | rdfile_ridentifier4, """\
$RFMT
""")
add_test_lines("mol or rxn identifier",
       rdfile_midentifier1 | rdfile_midentifier2 | rdfile_midentifier3 | \
       rdfile_ridentifier1 | rdfile_ridentifier3 | rdfile_ridentifier4, """\
$MFMT $MIREG 123456
$RFMT
""")

datatest_mol = """\
$DTYPE MOL:MDLNUMBER
$DATUM AAA00011122
$DTYPE MOL:MOLNAME
$DATUM HYDROCHLORIC ACID
$DTYPE MOL:MOLECULAR.WEIGHT
$DATUM 271.828
$DTYPE MOL:SUPPLIER(1)
$DATUM ........................
$DTYPE MOL:SUPPLIER(2)
$DATUM PUBLIX
"""

datatest_rxn = """\
$DTYPE rxn:VARIATION(1):rxnTEXT(1)
$DATUM CrCl3
$DTYPE rxn:VARIATION(1):LITTEXT(1)
$DATUM A G Repin, Y Y Makarov-Zemlyanskii, Igor Serpinski, Zur Russ Fiz-Chim, 44+
, p.2360, 1974
$DTYPE rn:VARIATION(1):CATALYST(1):REGNO
$DATUM $MFMT $MIREG 688
"""

add_test("dtype/datum", Rep(dtype + datum), datatest_mol)


add_test("rdfile header", rdfile_header, """\
$RDFILE 1
$DATM    10/17/91 10:41
""")

add_test("rdfile 1", rdfile_format, """\
$RDFILE 1
$DATM    10/17/91 10:41
$MFMT $MIREG 123456
""" + example_molfile + datatest_mol)

add_test("rdfile 2", rdfile_format, """\
$RDFILE 1
$DATM    10/17/91 10:41
$RFMT $RIREG 7439
""" + example_rxnfile + datatest_rxn)


add_test_lines("SD item headers", item_header, """\
>  <MELTING.POINT>
>  55     (MD-08974)     <BOILING.POINT>   DT12
>  DT12   55
>  (MD-0894)   <BOILING.POINT>   FROM ARCHIVES
>  <Ketones> (AW 01187)
""")

add_test("data_element", data_element, """\
>  <CATNAME> (AW 00014)
5-(2-Methylthiazol-4-yl)thiophene-2-sulphonyl chloride

""")

example_sdrecord = """\
 
  -ISIS-  05220009292D
 
 15 16  0  0  0  0  0  0  0  0999 V2000
   -0.0068    0.6249    0.0000 C   0  0  0  0  0  0  0  0  0  0  0  0
   -1.0732   -0.0034    0.0000 C   0  0  0  0  0  0  0  0  0  0  0  0
    1.0698    0.0102    0.0000 S   0  0  0  0  0  0  0  0  0  0  0  0
   -0.0102    1.8610    0.0000 C   0  0  0  0  0  0  0  0  0  0  0  0
   -3.2161   -0.0102    0.0000 N   0  0  0  0  0  0  0  0  0  0  0  0
   -1.0664   -1.2362    0.0000 C   0  0  0  0  0  0  0  0  0  0  0  0
    2.1395    0.6351    0.0000 C   0  0  0  0  0  0  0  0  0  0  0  0
    2.1361    1.8746    0.0000 C   0  0  0  0  0  0  0  0  0  0  0  0
   -3.2127   -1.2498    0.0000 C   0  0  0  0  0  0  0  0  0  0  0  0
   -2.1327   -1.8610    0.0000 S   0  0  0  0  0  0  0  0  0  0  0  0
    3.2161    0.0238    0.0000 S   0  0  3  0  0  0  0  0  0  0  0  0
   -4.2790   -1.8746    0.0000 C   0  0  0  0  0  0  0  0  0  0  0  0
    2.3365   -0.8388    0.0000 O   0  0  0  0  0  0  0  0  0  0  0  0
    4.0821   -0.8388    0.0000 O   0  0  0  0  0  0  0  0  0  0  0  0
    4.2790    0.6554    0.0000 Cl  0  0  0  0  0  0  0  0  0  0  0  0
  1  2  1  0  0  0  0
  1  3  1  0  0  0  0
  1  4  2  0  0  0  0
  2  5  1  0  0  0  0
  2  6  2  0  0  0  0
  3  7  1  0  0  0  0
  4  8  1  0  0  0  0
  5  9  2  0  0  0  0
  6 10  1  0  0  0  0
  7 11  1  0  0  0  0
  9 12  1  0  0  0  0
 11 13  2  0  0  0  0
 11 14  2  0  0  0  0
 11 15  1  0  0  0  0
  7  8  2  0  0  0  0
  9 10  1  0  0  0  0
M  END
>  <code> (AW 00014)
AW 00014

>  <CATNAME> (AW 00014)
5-(2-Methylthiazol-4-yl)thiophene-2-sulphonyl chloride

>  <Sulphonyl_halides> (AW 00014)
x

>  <Monomer> (AW 00014)
x

>  <Price1> (AW 00014)
1.650000000000000e+001

>  <Price2> (AW 00014)
6.600000000000000e+001

>  <wt1> (AW 00014)
0.5

>  <wt2> (AW 00014)
2.5

$$$$
"""

add_test("SD record", sdfile_record, example_sdrecord)


def test(debug_level = 0):
    test_list.test(debug_level = debug_level)

def dump():
    test_list.dump()
       

if __name__ == "__main__":
    test(debug_level = 1)
