from Martel.formats.PDB_2_1 import *

import support
test_list = support.Storage()

pdb1plm = """\
HEADER    COMPLEX (PROTEIN/PEPTIDE)               09-JAN-98   1PLM              
TITLE     ARABIDOPSIS PROFILIN 1 COMPLEXED WITH POLY-L-PROLINE,                 
TITLE    2 THEORETICAL MODEL                                                    
COMPND    MOL_ID: 1;                                                            
COMPND   2 MOLECULE: PROFILIN 1;                                                
COMPND   3 CHAIN: A;                                                            
COMPND   4 ENGINEERED: YES;                                                     
COMPND   5 MOL_ID: 2;                                                           
COMPND   6 MOLECULE: POLY-L-PROLINE;                                            
COMPND   7 CHAIN: B;                                                            
COMPND   8 ENGINEERED: YES                                                      
SOURCE    MOL_ID: 1;                                                            
SOURCE   2 ORGANISM_SCIENTIFIC: ARABIDOPSIS THALIANA;                           
SOURCE   3 ORGANISM_COMMON: MOUSE-EAR CRESS;                                    
SOURCE   4 EXPRESSION_SYSTEM: ESCHERICHIA COLI;                                 
SOURCE   5 EXPRESSION_SYSTEM_STRAIN: BL21 (DE3);                                
SOURCE   6 EXPRESSION_SYSTEM_PLASMID: PET11;                                    
SOURCE   7 MOL_ID: 2;                                                           
SOURCE   8 SYNTHETIC: NON-BIOLOGICAL SOURCE                                     
KEYWDS    ACTIN-BINDING, POLY-L-PROLINE, CYTOSKELETON,                          
KEYWDS   2 SIGNAL TRANSDUCTION, COMPLEX (PROTEIN/PEPTIDE)                       
EXPDTA    THEORETICAL MODEL                                                     
AUTHOR    R.T.SHIGETA,K.S.THORN,C.E.SCHUTT                                      
REVDAT   1   29-APR-98 1PLM    0                                                
JRNL        AUTH   K.S.THORN,H.E.CHRISTENSEN,R.SHIGETA JUNIOR,                  
JRNL        AUTH 2 D.H.HUDLLER JUNIOR,L.SHALABY,U.LINDBERG,N.H.CHUA,            
JRNL        AUTH 3 C.E.SCHUTT                                                   
JRNL        TITL   THE CRYSTAL STRUCTURE OF A MAJOR ALLERGEN FROM               
JRNL        TITL 2 PLANTS                                                       
JRNL        REF    STRUCTURE (LONDON)            V.   5    19 1997              
JRNL        REFN   ASTM STRUE6  UK ISSN 0969-2126                 2005          
REMARK   1                                                                      
REMARK   2                                                                      
REMARK   2 RESOLUTION. NOT APPLICABLE.                                          
REMARK   3                                                                      
REMARK   3 REFINEMENT.                                                          
REMARK   3   PROGRAM     : INSIGHT II                                           
REMARK   3   AUTHORS     : BIOSYM                                               
REMARK   3                                                                      
REMARK   3  OTHER REFINEMENT REMARKS: 1200 CYCLES OF NEWTON-RAPHSON             
REMARK   3  MINIMIZATION IN VACUO.                                              
REMARK   4                                                                      
REMARK   4 1PLM COMPLIES WITH FORMAT V. 2.2, 16-DEC-1996                        
REMARK 220                                                                      
REMARK 220 EXPERIMENTAL DETAILS                                                 
REMARK 220  EXPERIMENT TYPE: THEORETICAL MODELLING                              
REMARK 220                                                                      
REMARK 220 REMARK:                                                              
REMARK 220  MODELLING PROGRAM: INSIGHT II                                       
REMARK 220  PROGRAM AUTHORS: BIOSYM/MSI                                         
REMARK 220  MODELLING EXPERIMENT: A POLY-L-PROLINE OCTAMER WAS                  
REMARK 220  MANUALLY DOCKED TO THE REFINED STRUCTURE OF ARABIDOPSIS             
REMARK 220  PROFILIN 1 AND ENERGY MINIMIZED IN INSIGHT II.                      
REMARK 225                                                                      
REMARK 225 THEORETICAL MODEL                                                    
REMARK 225 THE COORDINATES IN THIS ENTRY REPRESENT A MODEL STRUCTURE.           
REMARK 225 PROTEIN DATA BANK CONVENTIONS REQUIRE THAT CRYST1 AND                
REMARK 225 SCALE RECORDS BE INCLUDED, BUT THE VALUES ON THESE                   
REMARK 225 RECORDS ARE MEANINGLESS.                                             
REMARK 500                                                                      
REMARK 500 GEOMETRY AND STEREOCHEMISTRY                                         
REMARK 500 SUBTOPIC: COVALENT BOND LENGTHS                                      
REMARK 500                                                                      
REMARK 500 THE STEREOCHEMICAL PARAMETERS OF THE FOLLOWING RESIDUES              
REMARK 500 HAVE VALUES WHICH DEVIATE FROM EXPECTED VALUES BY MORE               
REMARK 500 THAN 4*RMSD AND BY MORE THAN 0.150 ANGSTROMS (M=MODEL                
REMARK 500 NUMBER; RES=RESIDUE NAME; C=CHAIN IDENTIFIER; SSEQ=SEQUENCE          
REMARK 500 NUMBER; I=INSERTION CODE).                                           
REMARK 500                                                                      
REMARK 500 STANDARD TABLE:                                                      
REMARK 500 FORMAT: (10X,I3,1X,A3,1X,A1,I4,A1,1X,2(A4,A1,3X),12X,F5.3)           
REMARK 500                                                                      
REMARK 500 EXPECTED VALUES: ENGH AND HUBER, 1991                                
REMARK 500                                                                      
REMARK 500  M RES CSSEQI ATM1   RES CSSEQI ATM2   DEVIATION                     
REMARK 500  0 MET A  73   SD    MET A  73   CE      0.156                       
REMARK 800                                                                      
REMARK 800 SITE                                                                 
REMARK 800 SITE_IDENTIFIER: PPB                                                 
REMARK 800 SITE_DESCRIPTION: POLY-L-PROLINE BINDING SITE.                       
REMARK 999                                                                      
REMARK 999 SEQUENCE                                                             
REMARK 999 1PLM  A    SWS     Q42449       1 -     1 NOT IN ATOMS LIST          
REMARK 999                                                                      
REMARK 999 MET A 1 OF SEQUENCE IS REMOVED BY THE EXPRESSION SYSTEM.             
DBREF  1PLM A    2   131  SWS    Q42449   PRO1_ARATH       2    131             
DBREF  1PLM B    1     8  PDB    1PLM     1PLM             1      8             
SEQRES   1 A  130  SER TRP GLN SER TYR VAL ASP ASP HIS LEU MET CYS ASP          
SEQRES   2 A  130  VAL GLU GLY ASN HIS LEU THR ALA ALA ALA ILE LEU GLY          
SEQRES   3 A  130  GLN ASP GLY SER VAL TRP ALA GLN SER ALA LYS PHE PRO          
SEQRES   4 A  130  GLN LEU LYS PRO GLN GLU ILE ASP GLY ILE LYS LYS ASP          
SEQRES   5 A  130  PHE GLU GLU PRO GLY PHE LEU ALA PRO THR GLY LEU PHE          
SEQRES   6 A  130  LEU GLY GLY GLU LYS TYR MET VAL ILE GLN GLY GLU GLN          
SEQRES   7 A  130  GLY ALA VAL ILE ARG GLY LYS LYS GLY PRO GLY GLY VAL          
SEQRES   8 A  130  THR ILE LYS LYS THR ASN GLN ALA LEU VAL PHE GLY PHE          
SEQRES   9 A  130  TYR ASP GLU PRO MET THR GLY GLY GLN CYS ASN LEU VAL          
SEQRES  10 A  130  VAL GLU ARG LEU GLY ASP TYR LEU ILE GLU SER GLU LEU          
SEQRES   1 B    8  PRO PRO PRO PRO PRO PRO PRO PRO                              
HELIX    1   1 TRP A    3  ASP A    9  1                                   7    
HELIX    2   2 PRO A   44  GLU A   55  1                                  12    
HELIX    3   3 GLY A  112  GLU A  128  1                                  17    
SHEET    1   A 6 MET A  73  ILE A  75  0                                        
SHEET    2   A 6 VAL A  82  LYS A  86 -1  N  LYS A  86   O  MET A  73           
SHEET    3   A 6 GLY A  90  LYS A  96 -1  N  ILE A  94   O  ILE A  83           
SHEET    4   A 6 ALA A 100  ASP A 107 -1  N  TYR A 106   O  GLY A  91           
SHEET    5   A 6 ALA A  22  GLY A  27 -1  N  LEU A  26   O  LEU A 101           
SHEET    6   A 6 VAL A  32  GLN A  35 -1  N  ALA A  34   O  ILE A  25           
SHEET    1   B 2 LEU A  65  LEU A  67  0                                        
SHEET    2   B 2 GLU A  70  TYR A  72 -1  N  TYR A  72   O  LEU A  65           
CISPEP   1 GLU A  108    PRO A  109          0         1.34                     
SITE     1 PPB  5 TRP A   3  TYR A   6  TRP A  33  TYR A 125                    
SITE     2 PPB  5 LEU A 126                                                     
CRYST1    1.000    1.000    1.000  90.00  90.00  90.00 P 1           1          
ORIGX1      1.000000  0.000000  0.000000        0.00000                         
ORIGX2      0.000000  1.000000  0.000000        0.00000                         
ORIGX3      0.000000  0.000000  1.000000        0.00000                         
SCALE1      1.000000  0.000000  0.000000        0.00000                         
SCALE2      0.000000  1.000000  0.000000        0.00000                         
SCALE3      0.000000  0.000000  1.000000        0.00000                         
ATOM      1  N   SER A   2      -1.954  -5.450  -9.185  1.00  6.40           N  
ATOM      2  CA  SER A   2      -2.248  -3.983  -9.184  1.00  6.53           C  
ATOM      3  C   SER A   2      -2.070  -3.393  -7.792  1.00  6.01           C  
ATOM      4  O   SER A   2      -2.061  -4.114  -6.807  1.00  6.88           O  
ATOM      5  CB  SER A   2      -3.701  -3.744  -9.594  1.00  5.66           C  
ATOM   1052  CD  PRO B   8       1.253   4.917  -9.541  1.00 20.00           C  
ATOM   1053  OXT PRO B   8       2.335   8.253  -8.703  1.00  0.00           O  
TER    1054      PRO B   8                                                      
MASTER       54    0    0    3    8    0    2    6 1052    2    0   11          
END                                                                             
"""

test_list.add_test("burn test", format, pdb1plm)

def test():
    test_list.test()

def dump():
    test_list.dump()
