from Martel.formats.PIR_3_0 import *

import support

test_list = support.Storage()
add_test = test_list.add_test
add_test_lines = test_list.add_test_lines

s="""\
 
                P R O T E I N  S E Q U E N C E  D A T A B A S E
                             of PIR-International
 
                      Section 1. Fully Classified Entries
                       Release 66.00, September 30, 2000
                       20471 sequences, 8029284 residues
 
                       Protein Information Resource (PIR)*
                    National Biomedical Research Foundation
                          3900 Reservoir Road, N.W.,
                          Washington, DC  20007, USA
 
   Japan International Protein           Munich Information Center for
   Information Database (JIPID)             Protein Sequences (MIPS)
         Amakubo 1-16-1          GSF-Forschungszentrum f. Umwelt und Gesundheit
    Tsukuba 305-0005, Japan            am Max-Planck-Instut f. Biochemie
                                  Am Klopferspitz 18, D-82152 Martinsried, FRG
 
   This database may be redistributed without prior consent, provided that
   this notice be given to each user and that the words "Derived from" shall
   precede this notice if the database has been altered by the redistributor.
 
                       Copyright 2000, PIR-International.
 
                       *PIR is a registered mark of NBRF.
\\\\\\
"""
add_test("header", header, s)
del s

add_test_lines("entry", entry, """\
ENTRY           JC7119  #type complete
ENTRY           PC7076  #type fragment
ENTRY           T42219  #type complete
ENTRY           CCSF  #type complete
ENTRY           DENCED  #type fragments
""")

add_test("title 1", title, """\
TITLE           probable transposase - Streptomyces coelicolor (fragment)
""")
add_test("title 2", title, """\
TITLE           probable IS element ATP-binding protein - Streptomyces
                coelicolor (fragment)
""")
add_test("title 3", title, """\
TITLE           probable lipid metabolism protein, sphingomyelinase family
                similarity - fission yeast (Schizosaccharomyces pombe)
                (fragment)
""")
add_test("title 4", title, """\
TITLE           cytochrome c [validated] - human
""")
add_test("title 5", title, """\
TITLE           cytochrome c - Schreibers's long-fingered bat (tentative
                sequence)
""")
add_test("title 6", title, """\
TITLE           plastoquinol--plastocyanin reductase (EC 1.10.99.1)
                cytochrome f precursor - liverwort (Marchantia polymorpha)
                chloroplast
""")
# F69392, and T02444, C30315, H82063 has the same problem.
# Note the space count after the TITLE!
add_test("title 7", title, """\
TITLE          
                CDP-diacylglycerol--glycerol-3-phosphate-3-phosphatidyltrans
                ferase (pgsA-1) homolog - Archaeoglobus fulgidus
""")

add_test("alternate_names 1", alternate_names, """\
ALTERNATE_NAMES cytochrome c T
""")
add_test("alternate_names 2", alternate_names, """\
ALTERNATE_NAMES iso-1-cytochrome c; protein GTA109; protein J1653; protein
                YJR048w
""")
add_test("alternate_names 3", alternate_names, """\
ALTERNATE_NAMES cytochrome c553; soluble cytochrome f
""")
# A28451
add_test("alternate_names 3", alternate_names, """\
ALTERNATE_NAMES
                CMP-N-acetylneutraminate-alpha-N-acetyl-galactosamide-alpha-
                2,6-sialyltransferase
""")

add_test("contains 1", contains, """\
CONTAINS        ubiquinol--cytochrome-c reductase chain 5;
                ubiquinol--cytochrome-c reductase chain 9
""")
add_test("contains 2", contains, """\
CONTAINS        ubiquinol--cytochrome-c reductase (EC 1.10.2.2) cytochrome
                b; ubiquinol--cytochrome-c reductase (EC 1.10.2.2)
                cytochrome c1
""")
add_test("contains 3", contains, """\
CONTAINS        cytochrome b5, erythrocyte form
""")

add_test("contains 4", contains, """\
CONTAINS        lanosterol 14 alpha-demethylase; vitamin D3 25-hydroxylase
                (EC 1.14.14.-)
""")

add_test("organism_identifier 1", organism_identifier, """\
ORGANISM        #formal_name Antirrhinum majus #common_name garden snapdragon
""")

add_test("organism_identifier 2", organism_identifier, """\
ORGANISM        #formal_name mitochondrion Colobus guereza #common_name
                guereza
""")

add_test("organism_identifier 3", organism_identifier, """\
ORGANISM        #formal_name mitochondrion Pygathrix roxellana
""")

add_test("organism_identifier 4", organism_identifier, """\
ORGANISM        #formal_name mitochondrion Pygathrix roxellana
""")

add_test("organism_identifier 5", organism_identifier, """\
ORGANISM        #formal_name Oscheius sp. PS1131
""")
add_test("organism_identifier 6", organism_identifier, """\
ORGANISM        #formal_name murine endogenous retrovirus ERV-L
""")
add_test("organism_identifier 7", organism_identifier, """\
ORGANISM        #formal_name Cryphonectria parasitica, Endothia parasitica
                #common_name chestnut blight fungus
""")
add_test("organism_identifier 8", organism_identifier, """\
ORGANISM        #formal_name Ovis orientalis aries, Ovis ammon aries
                #common_name domestic sheep
""")

add_test("organism_variety 1", organism_variety, """\
   #variety     ATCC 96134
""")
add_test("organism_variety 2", organism_variety, """\
   #variety     columbia
""")
add_test("organism_variety 3", organism_variety, """\
   #variety     isolate Australia, individual c; isolate Ottawa, Canada,
                individual d; isolate France, individual e, isolate
                Brazzaville, Congo, individual f
""")
add_test("organism_variety 4", organism_variety, """\
   #variety     subtype ayw, patient E
""")

add_test("organism_note 1", organism_note, """\
   #note        Synechococcus sp. PCC 6301 (ATCC 27144) was named Anacystis
                nidulans in other culture collections, e.g., CCAP, SAUG, and
                UTEX
""")

add_test("organism 1", organism, """\
ORGANISM        #formal_name Brassica napus #common_name rape
""")
add_test("organism 2", organism, """\
ORGANISM        #formal_name Pseudomonas stutzeri
   #variety     strain ZoBell
""")
add_test("organism 3", organism, """\
ORGANISM        #formal_name Synechococcus sp.
   #variety     PCC 6301
   #note        Synechococcus sp. PCC 6301 (ATCC 27144) was named Anacystis
                nidulans in other culture collections, e.g., CCAP, SAUG, and
                UTEX
""")
add_test("organism 4", organism, """\
ORGANISM        #formal_name Arabidopsis thaliana #common_name mouse-ear
                cress
   #variety     columbia
""")

add_test("date 1", date, """\
DATE            23-Oct-1999 #sequence_revision 23-Oct-1999 #text_change
                23-Oct-1999
""")

add_test("date 2", date, """\
DATE            01-Oct-1999 #sequence_revision 12-Jan-1999 #text_change
                23-Dec-2000
""")

add_test("accessions 1", accessions, """\
ACCESSIONS      T31338
""")
add_test("accessions 2", accessions, """\
ACCESSIONS      T31338; T3133; T313; T31; T3; T
""")
add_test("accessions 3", accessions, """\
ACCESSIONS      T10984; T11882; S17418; S58080; S58021; S58059; S58058;
                S58060; S58079
""")
add_test("accessions 4", accessions, """\
ACCESSIONS      S22931; H33285; S21611; S70405; S70404; S21612; S21613;
                S21614; S21615; S21616; S21617; S21618; S21619; S21620;
                S21621; S21622; S21623; S21624; S21625
""")

add_test("ref_number", ref_number, """\
REFERENCE       Z18677
""")

add_test("#authors 1", ref_authors, """\
   #authors     Olmstead, R.G.; Reeves, P.A.
""")

add_test("#authors 2", ref_authors, """\
   #authors     Sakai, J.; Rawson, R.B.; Espenshade, P.J.; Cheng, D.;
                Seegmiller, A.C.; Goldstein, J.L.; Brown, M.S.
""")

add_test("#authors 3", ref_authors, """\
   #authors     Van Wageningen, A.; Kirkpatrick, P.; Williams, D.; Harris,
                B.; Kershaw, J.; Lennard, N.; Jones, M.; Jones, S.;
                Solenberg, P.
""")

add_test_lines("#journal", journal_subitem, """\
   #journal     Chem Biol (1998) 3:155-162
   #journal     Mol. Biol. Evol. (1996) 13:1351-1362
   #journal     Mol. Biol. Evol. (1996) 13:1351-1362
   #journal     J. Bacteriol. (1990) 172:3534
   #journal     Acta Crystallogr. (1973) B29:943-956
   #journal     Mol. Biol. (Mosk.) (1990) 24:968-976
""")
add_test("#journal (multiline)", journal_subitem, """\
   #journal     Int. Symp. Princess Takamatsu Cancer Res. Fund (1982)
                12:31-40
""")
add_test("#title 1", title_subitem, """\
   #title       Activity and substrate specificity of the murine STK2 serine=
""")
add_test("#title 2", title_subitem, """\
   #title       Akt phosphorylation site found in human caspase-9 is absent
                in mouse caspase-9.
""")
add_test("#title 3", title_subitem, """\
   #title       Expression of the eicosapentaenoic acid synthesis gene
                cluster from Shewanella sp. in a transgenic marine
                cyanobacterium, Synechococcus sp.
""")

# Yes, the first date really is in PIR.
add_test_lines("#submission", ref_submission, """\
   #submission  submitted to the EMBL Data Library, January 1299
   #submission  submitted to the EMBL Data Library, November 1996
   #submission  submitted to the Protein Sequence Database, July 1999
""")

add_test("#description 1", ref_description, """\
   #description Nucleotide sequences of the fap1 locus.
""")
add_test("#description 2", ref_description, """\
   #description Sequence analysis of a 3.5 Mb contig in human 19p13.3
                containing a serine protease gene cluster.
""")
add_test("#description 3", ref_description, """\
   #description Identification and preliminary characterization of an nusual
                leuciune-rich repeat receptor-like protein kinase from
                morning glory (Ipomoea nil).
""")


add_test("xref subitem (medline)", xref_subitem, """\
   #cross-references MUID:20012730
""")
add_test("xref subitem (PDB)", xref_subitem, """\
   #cross-references PDB:1HRC
""")
add_test("xref subitem (BioMagResBank)", xref_subitem, """\
   #cross-references BMRB:4313
""")

add_test("ref_acc", ref_acc, """\
   #accession   T17467
""")
add_test("ref_acc_status 1", ref_acc_status, """\
      ##status preliminary
""")
add_test("ref_acc_status 2", ref_acc_status, """\
      ##status preliminary; nucleic acid sequence not shown; translation not
                shown
""")

add_test_lines("ref_acc_molecule_type", ref_acc_molecule_type, """\
      ##molecule_type DNA
      ##molecule_type DNA; mRNA
      ##molecule_type DNA; protein
      ##molecule_type genomic RNA
      ##molecule_type genomic RNA; mRNA
      ##molecule_type genomic RNA; protein
      ##molecule_type mRNA
      ##molecule_type mRNA; DNA
      ##molecule_type mRNA; genomic RNA
      ##molecule_type mRNA; protein
      ##molecule_type protein
      ##molecule_type protein; DNA
      ##molecule_type protein; mRNA
""")


add_test("ref_acc_residues 1", ref_acc_residues, """\
      ##residues 1-53,'W',54-292 ##label MA2
""")
add_test("ref_acc_residues 2", ref_acc_residues, """\
      ##residues 1-8,'RHSR',13,'SYRPRPA',21,'WR',25-28,'WYSRSSK',39-60,'AA',
                64-274 ##label USU
""")
add_test("ref_acc_residues 3", ref_acc_residues, """\
      ##residues 48-50,'X',52-53,'X',55-67;75-82;91-97,'Q',99-108,110-111
                ##label FUW
""")
add_test("ref_acc_residues 4", ref_acc_residues, """\
      ##residues
                8-23;25-28;31-32;37-57;59;61;63-64;66-81;130-144;146-159;
                151-155 ##label VON
""")
add_test("ref_acc_xrefs 1", ref_acc_xrefs, """\
      ##cross-references DDBJ:AB030228
""")

add_test("ref_acc_xrefs 2", ref_acc_xrefs, """\
      ##cross-references EMBL:AJ012287; NID:e1361091; PID:e1361092;
                PIDN:CAA09979.1
""")
add_test("ref_acc_xrefs 3", ref_acc_xrefs, """\
      ##cross-references EMBL:AJ012287; NID:e1361091; PID:e1361092;
                PIDN:CAA09979.1; PIDN:CAA09979.2; PIDN:CAA09979.3;
                PIDN:CAA09979.4; PIDN:CAA09979.5
""")

add_test("ref_acc_experimental_source 1", ref_acc_experimental_source, """\
      ##experimental_source strain 777-3A
""")
add_test("ref_acc_experimental_source 2", ref_acc_experimental_source, """\
      ##experimental_source liver
""")
add_test("ref_acc_experimental_source 3", ref_acc_experimental_source, """\
      ##experimental_source placenta; placental aromatase deficiency patient
""")
# G72850
add_test("ref_acc_experimental_source 4", ref_acc_experimental_source, """\
      ##experimental_source strain C6H;;P2:F40781 C;Acc (F40781) merged into
                P2:G72850 #date 22-NOV-99 #staff PBM
""")

add_test_lines("ref_acc_genetics", ref_acc_genetics, """\
      ##genetics CGT1
      ##genetics FDX1
      ##genetics NTER
""")

add_test("ref_acc_note 1", ref_acc_note, """\
      ##note this sequence represents the open reading frame of the spoIIIC
                locus prior to chromosomal rearrangement
""")

add_test("ref_acc_note 2", ref_acc_note, """\
      ##note the authors translated the codon CAA for residue 317 as Gly
""")
# A45121
add_test("ref_acc_note 3", ref_acc_note, """\
      ##note this translation is not annotated in GenBank entry HUMADRENB,
                release 113.0 #date 19-Apr-2000 #staff WCB
""")

# XXX Add more reference tests 

add_test("comment 1", comment, """\
COMMENT         The presence of Lys-104 is not certain.
""")
add_test("comment 2", comment, """\
COMMENT         We have arranged the amino acids in positions 88-92 by
                homology with the other cytochrome c sequences. This
                arrangement is contrary to the authors'.
""")

add_test("genetics_identifier 1", genetics_identifier, """\
GENETICS
""")
add_test("genetics_identifier 2", genetics_identifier, """\
GENETICS        ST2
""")
add_test("genetics_gene 1", genetics_gene, """\
   #gene        CESP:E04A4.7
""")
add_test("genetics_gene 2", genetics_gene, """\
   #gene        SGD:CYC7; CYP3; MIPS:YEL039c
""")
add_test("genetics_gene 3", genetics_gene, """\
   #gene        tra5_4
""")
add_test("genetics_gene_xrefs 1", genetics_gene_xrefs, """\
      ##cross-references GDB:141582
""")
add_test("genetics_gene_xrefs 2", genetics_gene_xrefs, """\
      ##cross-references MIPS:YEL039c; SGD:S0000765
""")
add_test("genetics_map_position 1", genetics_map_position, """\
   #map_position 4
""")
add_test("genetics_map_position 2", genetics_map_position, """\
   #map_position 5L
""")
add_test("genetics_map_position 3", genetics_map_position, """\
   #map_position 71.6-76.2
""")
add_test("genetics_map_position 4", genetics_map_position, """\
   #map_position 2 36A 10-11
""")
add_test("genetics_map_position 5", genetics_map_position, """\
   #map_position 43.9-46.6% of the plasmid genome
""")
add_test("genetics_genome 1", genetics_genome, """\
   #genome      plasmid R68.45
""")
add_test("genetics_genome 2", genetics_genome, """\
   #genome      mitochondrion
""")
add_test("genetics_genome 3", genetics_genome, """\
   #genome      nuclear
""")
add_test("genetics_genome 4", genetics_genome, """\
   #genome      cryptic lambdoid prophage DLP12
""")
add_test("genetics_genetic_code 1", genetics_genetic_code, """\
   #genetic_code SGC2
""")
add_test("genetics_genetic_code 2", genetics_genetic_code, """\
   #genetic_code SGC9
""")
add_test("genetics_start_codon 1", genetics_start_codon, """\
   #start_codon TTG
""")
# ODFF1Y has ATAA as a start codon?
add_test("genetics_start_codon 2", genetics_start_codon, """\
   #start_codon GTG
""")
add_test("genetics_introns 1", genetics_introns, """\
   #introns     7/2
""")
add_test("genetics_introns 2", genetics_introns, """\
   #introns     41/3; 69/3; 116/3; 157/2; 184/3; 209/1; 239/3; 264/3; 300/3;
                326/3; 341/3
""")
add_test("genetics_introns 3", genetics_introns, """\
   #introns     17/3; 37/1; 69/2; 104/3; 147/1; 167/3; 190/3; 219/3; 267/1;
                298/1; 348/3; 380/1; 416/3; 478/2; 536/3; 564/3; 621/2; 662/
                3; 702/3; 735/1; 776/3; 821/2; 850/3; 879/3; 943/3; 992/2;
                1019/3; 1051/3; 1094/3; 1119/3; 1137/2; 1175/3; 1197/3;
                1260/3; 1319/3
""")
add_test("genetics_introns 4", genetics_introns, """\
   #introns     23/1; 59/2; 92/1; 160/1; 213/2; 249/1; 297/1; 359/1; 726/1;
                921/1; 1000/1 #status incomplete
""")
add_test("genetics_introns 5", genetics_introns, """\
   #introns     #status absent
""")
add_test("genetics_mobile_element 1", genetics_mobile_element, """\
   #mobile_element insertion sequence IS21
""")
add_test("genetics_mobile_element 2", genetics_mobile_element, """\
   #mobile_element transposons
""")
add_test("genetics_mobile_element 3", genetics_mobile_element, """\
   #mobile_element retrotransposons Osser
""")
add_test("genetics_mobile_element 4", genetics_mobile_element, """\
   #mobile_element insertion sequence ISH1.8
""")
add_test("genetics_note 1", genetics_note, """\
   #note        strain D273-10B/A21
""")
add_test("genetics_note 2", genetics_note, """\
   #note        part of an operon containing 18 genes involved in
                hydrogenase activity and expression
""")

add_test("genetics 1", genetics, """\
GENETICS
   #gene        napC
""")
add_test("genetics 2", genetics, """\
GENETICS
   #gene        torC
   #start_codon GTG
""")
add_test("genetics 3", genetics, """\
GENETICS
   #gene        SGD:QCR6; CR17; MIPS:YFR033c
      ##cross-references SGD:S0001929; MIPS:YFR033c
   #map_position 6R
   #genome      nuclear
""")
add_test("genetics 4", genetics, """\
GENETICS
   #gene        FlyBase:mt:Cyt-b
      ##cross-references FlyBase:FBgn0013678
   #genome      mitochondrion
   #genetic_code SGC4
""")
add_test("genetics 5", genetics, """\
GENETICS
   #gene        hupJ
   #start_codon TTG
   #note        part of an operon containing 18 genes involved in
                hydrogenase activity and expression
""")

# IEECC7 has a wierd order with mobile_element first followed by start_codon
# So does IEEBB1, IEECB1, JC5304
add_test("genetics 6", genetics, """\
GENETICS
   #mobile_element insertion sequence IS1
   #start_codon GTG
""")

# so does IEECB9
add_test("genetics 7", genetics, """\
GENETICS        IA3
   #gene        insA_3
   #mobile_element insertion sequence IS1
   #start_codon GTG
""")


# Can be multiple genetics notes
add_test("genetics 8", genetics, """\
GENETICS        H10
   #gene        CESP:F17E9.10
   #map_position 4
   #note        <H11>; Gene: CESP:F55G1.2; Map position: 4
   #note        <H12>; Gene: CESP:K06C4.5; Map position: 5
   #note        <H13>; Gene: CESP:K06C4.13
   #note        histones exist in large multigene families; it is possible
                that some of the genes shown here represent the same gene
""")
# T33084
add_test("genetics 9", genetics, """\
GENETICS
   #gene        CESP:K10E9.2
   #map_position 1
   #mobile_element transposable element Tc4
   #introns     71/3; 167/1; 213/2; 420/3
""")
# S77650
add_test("genetics 10", genetics, """\
GENETICS
   #mobile_element insertion sequence IS1221
   #genetic_code SGC3
""")
# S28721
add_test("genetics 11", genetics, """\
GENETICS
   #mobile_element retrotransposon-like element TRS 1.6
   #start_codon TTG
   #introns     627/3
""")

add_test("complex 1", complex, """\
COMPLEX         tightly bound to the photosynthetic reaction center complex
""")
add_test("complex 2", complex, """\
COMPLEX         associates in a heterotetramer with methylamine
                dehydrogenase large and small chains and amicyanin to form a
                soluble electron transfer chain; the complex forms a dimer
                in crystals
""")

add_test("function_identifier 1", function_identifier, """\
FUNCTION
""")
add_test("function_identifier 2", function_identifier, """\
FUNCTION        <5PRI>
""")
add_test("function_description 1", function_description, """\
   #description may be part of the water-oxidation complex of photosystem II
""")
add_test("function_description 2", function_description, """\
   #description the net reaction catalyzed by the ubiquinol--cytochrome-c
                reductase complex (complex III) is the oxidation of one
                molecule of ubiquinol to ubiquinone by two molecules of
                cytochrome c, with two hydrogen ions taken up from the
                mitochondrial matrix and four hydrogen ions released into
                the intermembrane space
""")
add_test("function_pathway 1", function_pathway, """\
   #pathway     respiratory chain
""")
add_test("function_pathway 2", function_pathway, """\
   #pathway     oxidative phosphorylation; respiratory chain
""")
add_test("function_pathway 3", function_pathway, """\
   #pathway     involved in pulmonary metabolism of endogenous carbonyl
                compounds and xenobiotic metabolism
""")
add_test("function_note 1", function_note, """\
   #note        this protein is also active in the phosphoroclastic reaction
""")

add_test("function 1", function, """\
FUNCTION
   #description accepts electrons from cytochrome-c3 hydrogenase (EC
                1.12.2.1) and transfers them to ferredoxin II
   #pathway     sulfate respiration
   #note        this protein is also active in the phosphoroclastic reaction
""")
add_test("function 2", function, """\
FUNCTION
   #description catalyzes oxidation of glucose-6-phosphate to
                gluconolactone-6-phosphate using NADP+; oxidoreductase
   #pathway     pentose phosphate pathway
   #note        catalyzes the first reaction of the pentose phosphate
                pathway and is a major intracellular source of NADPH for
                biosynthetic and detoxification reactions
   #note        a deficiency of this enzyme in erythrocytes is a cause of
                hemolytic anemia
""")

add_test("classification 1", classification, """\
CLASSIFICATION  #superfamily cytochrome c-L; cytochrome c6 homology
""")
add_test("classification 2", classification, """\
CLASSIFICATION  #superfamily T. aquaticus cytochrome c552; cytochrome c6
                homology
""")

add_test("keywords 1", keywords, """\
KEYWORDS        chromoprotein; heme; iron; metalloprotein
""")
add_test("keywords 2", keywords, """\
KEYWORDS        acetylated amino end; chromoprotein; electron transfer;
                heme; iron; metalloprotein; mitochondrion; oxidative
                phosphorylation; respiratory chain
""")

add_test("feature_identifier", feature_identifier, """\
FEATURE
""")

add_test_lines("feature_pos", feature_pos + Str("\n"), """\
1
277
9876543210
""")
add_test_lines("feature_range", feature_range + Str("\n"), """\
32-365
194-223
32-38
36-45
302-345
""")
add_test_lines("feature_seq", feature_seq + Str("\n"), """\
'A'
'Y'
'CFSFSLFQ'
""")

add_test("fragment 1", fragment + Str("\n"), """\
32-365
""")
add_test("fragment 2", fragment + Str("\n"), """\
32-365,
   'A'
""")
add_test("fragment 3", fragment + Str("\n"), """\
32-365,
   'A',
   9
""")
add_test("fragment 4", fragment + Str("\n"), """\
1,2,3,4,5,6
""")
add_test("fragment 5", fragment + Str("\n"), """\
1,2-3,'R',7-9,
   10,20-33
""")
add_test("fragment 6", fragment + Str("\n"), """\
1-4,11-44,111-444
""")
add_test("fragment 7", fragment + Str("\n"), """\
1-4,11-44,111-444,
   'E'
""")


add_test("feature_data 1", feature_data, """\
   277                 #active_site Cys #status predicted
""")
add_test("feature_data 2", feature_data, """\
   32-365              #domain long-chain alcohol dehydrogenase homology
                       #label LADH\\
""")
add_test("feature_data 3", feature_data, """\
   194-223             #region beta-alpha-beta NAD nucleotide-binding fold\\
""")
add_test("feature_data 4", feature_data, """\
   2                   #modified_site acetylated amino end (Ser) (in mature
                       form) #status experimental\\
""")
add_test("feature_data 5", feature_data, """\
   47,68,174           #binding_site zinc, catalytic (Cys, His, Cys) #status
                       predicted\\
""")
add_test("feature_data 6", feature_data, """\
   32-38,36-45,
   152-176,154-194,
   218-266,302-345     #disulfide_bonds #status experimental\\
""")
add_test("feature_data 7", feature_data, """\
   67,95,121,178,205,
   241,254,280,325,
   338,350,412         #binding_site carbohydrate (Asn) (covalent) #status
                       predicted
""")
add_test("feature_data 8", feature_data, """\
   22-456,'A',466-881  #product protein-tyrosine kinase nsk2, splice form 3
                       #status predicted #label MAT3\\
""")
add_test("feature_data 9", feature_data, """\
   1-2350,'CFSFSLFQ',
   2351-2512           #product fatty-acid synthase, splice form 2 #status
                       predicted #label MAT2\\
""")
add_test("feature_data 10", feature_data, """\
   161                 #active_site Cys #link OAS #status predicted\\
""")
add_test("feature_data 11", feature_data, """\
   14-274              #domain aldehyde dehydrogenase homology #link AADH
                       #label LAR\\
""")
add_test("feature_data 12", feature_data, """\
   56,84,90            #binding_site 4Fe-4S cluster (Cys) (covalent) #link
                       FE3 #status experimental\\
""")
# T07826
add_test("feature_data 13", feature_data, """\
   65-1035             #product #status predicted #label MAT\\
""")

add_test("summary 1", summary, """\
SUMMARY         #length 308 #checksum 1374
""")
add_test("summary 2", summary, """\
SUMMARY         #length 380  #molecular-weight 42592  #checksum 9761
""")

add_test("sequence 1", sequence, """\
SEQUENCE
                 5        10        15        20        25        30
       1/P Q A S R F L F K Q N R V R M I V D C H A T P V R V F Q D E
      31 A L M Q P L C L V G S T L R A P H G C H A Q Y M E N M G S I
      61 A S L T L A V I I N G N D E D G V G G R N S M R L W G L V V
      91 G H H T S A R C I P L P L R Y A C/
""")

add_test("sequence 2", sequence, """\
SEQUENCE
                 5        10
       1 W S G G G E F/I M H P
""")

add_test("record 1", record, \
r"""ENTRY           S53524  #type complete
TITLE           adrenodoxin precursor - mouse
ALTERNATE_NAMES adrenal ferredoxin; cytochrome P450-linked ferredoxin
ORGANISM        #formal_name Mus musculus #common_name house mouse
DATE            10-Sep-1999 #sequence_revision 10-Sep-1999 #text_change
                16-Jun-2000
ACCESSIONS      S53524; S60451; S60452
REFERENCE       S53524
   #authors     Stromstedt, M.; Watermann, M.R.
   #journal     Biochim. Biophys. Acta (1995) 1261:126-128
   #title       A full-length cDNA encoding mouse adrenodoxin.
   #cross-references MUID:95200960
   #accession   S53524
      ##molecule_type mRNA
      ##residues 1-188 ##label STR
      ##cross-references EMBL:L29123; NID:g457297; PIDN:AAA74303.1;
                PID:g457298
REFERENCE       S60451
   #authors     Itoh, S.; Iemura, O.; Yamada, E.; Yoshimura, T.; Tsujikawa,
                K.; Kohama, Y.; Mimura, T.
   #journal     Biochim. Biophys. Acta (1995) 1263:173-178
   #title       Mouse cytochrome P-450 linked ferredoxin: its cDNA cloning
                and inducibility by dibutyryladenosine 3',5'-cyclic
                monophosphate and forskolin.
   #cross-references MUID:95367595
   #accession   S60451
      ##molecule_type mRNA
      ##residues 1-188 ##label ITO
      ##cross-references EMBL:D43689; NID:g1065599; PIDN:BAA07786.1;
                PID:g1769821
      ##experimental_source clone F1-1
   #accession   S60452
      ##molecule_type mRNA
      ##residues 1-188 ##label ITW
      ##cross-references EMBL:D43690; NID:g1065600; PIDN:BAA07787.1;
                PID:g1769822
      ##experimental_source clone F41-1
GENETICS
   #genome      nuclear
CLASSIFICATION  #superfamily ferredoxin [2Fe-2S]; ferredoxin [2Fe-2S]
                homology
KEYWORDS        2Fe-2S; electron transfer; iron-sulfur protein;
                metalloprotein; mitochondrion
FEATURE
   1-64                #domain transit peptide (mitochondrion) #status
                       predicted #label TNP\
   65-188              #product adrenodoxin #status predicted #label MAT\
   93-157              #domain ferredoxin [2Fe-2S] homology #label FER\
   110,116,119,156     #binding_site 2Fe-2S cluster (Cys) (covalent) #status
                       predicted
SUMMARY         #length 188  #molecular-weight 20123  #checksum 5273
SEQUENCE
                 5        10        15        20        25        30
       1 M A A A P G A R L L R A A C A S V P F R G L D R C R L L V C
      31 G T G A G T A I S P W T P S P R L H A E A G P G R P L S V S
      61 A R A R S S S E D K I T V H F K N R D G E T L T T K G K I G
      91 D S L L D V V I E N N L D I D G F G A C E G T L A C S T C H
     121 L I F E D H I Y E K L D A I T D E E N D M L D L A F G L T D
     151 R S R L G C Q V C L T K A M D N M T V R V P E A V A D V R Q
     181 S V D M S K N S
///
""")

add_test("record 2", record, \
r"""ENTRY           DENCED  #type fragments
TITLE           glutamate dehydrogenase (EC 1.4.1.2) - Neurospora crassa
                (tentative sequence) (fragments)
ALTERNATE_NAMES glutamic dehydrogenase; NAD-specific glutamate dehydrogenase
ORGANISM        #formal_name Neurospora crassa
DATE            03-Aug-1984 #sequence_revision 03-Aug-1984 #text_change
                31-Mar-2000
ACCESSIONS      A92284; A92215; A32204; A00378
REFERENCE       A92284
   #authors     Haberland, M.E.; Smith, E.L.
   #journal     J. Biol. Chem. (1980) 255:7984-7992
   #title       Nicotinamide adenine dinucleotide-specific glutamate
                dehydrogenase of Neurospora crassa. Isolation and sequences
                of several cyanogen bromide peptides from the NH-2-terminal
                portion of the peptide chain.
   #cross-references MUID:80249569
   #accession   A92284
      ##molecule_type protein
      ##residues 1-356 ##label HAB
REFERENCE       A92215
   #authors     Austen, B.M.; Haberland, M.E.; Nyc, J.F.; Smith, E.L.
   #journal     J. Biol. Chem. (1977) 252:8142-8149
   #title       Nicotinamide adenine dinucleotide-specific glutamate
                dehydrogenase of Neurospora. IV. The COOH-terminal 669
                residues of the peptide chain; comparison with other
                glutamate dehydrogenases.
   #cross-references MUID:7802658
   #accession   A92215
      ##molecule_type protein
      ##residues 357-1025 ##label AUS
      ##note this is the final paper in a series
REFERENCE       A32204
   #authors     Vierula, P.J.; Kapoor, M.
   #journal     J. Biol. Chem. (1989) 264:1108-1114
   #title       NAD-specific glutamate dehydrogenase of Neurospora crassa.
                cDNA cloning and gene expression during derepression.
   #cross-references MUID:89093096
   #accession   A32204
      ##molecule_type mRNA
      ##residues 618-728,'N',730-763,'N',765-774,'V',776,'H',777-819,'ST',
                822-883,'D',885-923 ##label VIE
      ##cross-references GB:M23436; NID:g168845; PIDN:AAA33601.1;
                PID:g168846; GB:M21816
CLASSIFICATION  #superfamily glutamate dehydrogenase
KEYWORDS        NAD; oxidoreductase
FEATURE
   481,570             #binding_site substrate (Lys) #status predicted
SUMMARY         #length 1025 #checksum 3887
SEQUENCE
                 5        10        15        20        25        30
       1 M D A P D A P V P A R K L V D R L K D Q T P R H P S P Q P T
      31 V(P,Y)S K V D G G N H R Q/S A T V G Y V A P V F Q G K A E Q
      61 M K Q V K N I I V Q G G W I P E T L V D G Q I A W F Y N E L
      91 G I D D
///
""")

test = test_list.test
dump = test_list.dump

def test_file(infile):
    support.test_file(format, infile)

if __name__ == "__main__":
    test()
    #dump(debug_level = 1)

