from Martel.formats.blocks_12 import *

import support

test_list = support.Storage()
add_test = test_list.add_test
add_test_lines = test_list.add_test_lines

add_test_lines("ID line", ID_line, """\
ID   kringle; BLOCK
ID   C2; BLOCK
""")

add_test_lines("AC line", AC_line, """\
AC   IPB000001A; distance from previous block=(10,266)
AC   IPB000007E; distance from previous block=(-1,26)
""")

add_test_lines("DE line", DE_line, """\
DE   Protein phosphatase 2A regulatory subunit PR55
DE   Alkylbase DNA glycosidase (alkA family)
""")

add_test_lines("BL line", BL_line, """\
BL   ASL;  width=47; seqs=20; 99.5%=1771; strength=1740
BL   QGV;  width=14; seqs=104; 99.5%=824; strength=1070
BL   ATF;  width=37; seqs=20; 99.5%=1698; strength=1567
""")

add_test_lines("data line", data_line, """\
CYTI_VIGUN|Q06445  (  49) QVVSGTLYTITLEA  13
Q41897             (  85) QVVAGTMYYLTIEV   6
2ABA_HUMAN|Q00007  (  26) AEADIISTVEFNHSGELLATGDKGGRVVIFQQEQENK  32
SMPB_TREPA|O83214  (  -8) XXXXXXXXXMEDRLECGIALEGTEVKSVRAGHLSFPDAFAEMRGGELWL  44
""")

add_test("cluster 1", cluster, """\
OMPT_ECOLI|P09169  (  29) PDNINADISLGTLSGKTKERVYLA  66
P95750             (  29) PDNISTDISLGSLSGKTKERVYHP  54
O33641             (  40) PDNISTDISLGSLSGKTKERVYHP  54

OMPP_ECOLI|P34210  (  29) PEKISTEINLGTLSGKTKERVYEP  78

PGTE_SALTY|P06185  (  48) PDSVTTSLSVGVLNGKSRELVYDT  98

COLY_YERPE|P17811  (  31) PDSFTVAASTGMLSGKSHEMLYDA 100
""")

add_test("record 1", record, """\
ID   kringle; BLOCK
AC   IPB000001A; distance from previous block=(10,266)
DE   Kringle domain
BL   CCY;  width=14; seqs=44; 99.5%=717; strength=1059
PLMN_BOVIN|P06868  (  60) CEEETDFVCRAFQY  26
PLMN_ERIEU|Q29485  (  53) CEKETSFICRSFQY  34
PLMN_MOUSE|P20918  (  53) CEGETDFVCRSFQY  33
PLMN_PIG|P06867    (  34) CEAETNFICRAFQY  45

PLMN_HUMAN|P00747  (  53) CEEDEEFTCRAFQY  24
PLMN_MACMU|P12545  (  53) CEEEEEFTCRSFQY  17
Q15146             (  53) CEEDEEFTCRAFQY  24

HGFL_HUMAN|P26927  ( 186) CREAACVWCNGEEY  25
HGFL_MOUSE|P26928  ( 186) CREAVCVLCNGEDY  27
Q14870             ( 186) CREAACVWCNGEEY  25
P70521             ( 186) CREAVCVWCNGEDY  20

HGF_HUMAN|P14210   ( 206) CSEVECMTCNGESY  17
HGF_MOUSE|Q08048   ( 207) CSEVECMTCNGESY  17
HGF_RAT|P17945     ( 207) CSEVECMTCNGESY  17
Q64007             ( 207) CSEVECMTCNGESY  17
Q90978             ( 202) CSEVECMTCNGESY  17

Q90504             (  12) AEDVPCVRREGRDY 100
//
""")

data = """\
             Blocks Database Version 12.0, June 2000
       Copyright 2000 by Fred Hutchinson Cancer Research Center
             1100 Fairview AV N, Seattle, WA 98109, USA

   Please cite: S Henikoff & JG Henikoff (1991) Automated assembly of
   protein blocks for database searching, Nucleic Acids Res. 19:6565-6572.

   Blocks made by PROTOMAT for protein families documented in InterPro 1.0
   and SWISS-PROT 38: PROSITE patterns were not used. ID, AC and DE are
   adapted from prosite.dat; BL is PROTOMAT information. For each segment,
   the sequence ID is followed by the position of the first residue in
   the segment. Segments are clustered if >=80% of aligned residues match
   between any pair of segments. Sequence weights are shown to the right of
   each segment. The higher the weight the more dissimilar the segment is
   from other segments in the block. These weights were obtained using the
   position-based method of S Henikoff & JG Henikoff (1994), JMB 243:574-578.
   ==========================================================================
ID   kringle; BLOCK
AC   IPB000001C; distance from previous block=(34,337)
DE   Kringle domain
BL   GPW;  width=16; seqs=44; 99.5%=851; strength=1099
HGFL_HUMAN|P26927  ( 483) RVVGGHPGNSPWTVSL  18
Q14870             ( 483) RVVGGHPGNSPWTVSL  18
P70521             ( 488) RVVGGHPGNSPWTVSL  18
Q91691             ( 485) RIVGGVPGNSPWTVSL  23
Q90865             ( 476) RVVGGMPGNSPWTVSI  22
P70006             ( 486) RIVGGEPGNSPWTVSL  21

HGF_HUMAN|P14210   ( 450) PWCYTGNPLIPWDYCP  27
HGF_MOUSE|Q08048   ( 451) PWCYTGNPLIPWDYCP  27
HGF_RAT|P17945     ( 451) PWCYTGNPLVPWDYCP  32
Q64007             ( 451) PWCYTGNPLIPWDYCP  27
Q90978             ( 448) PWCYTDDPLIPWDYCP  32

PLMN_BOVIN|P06868  ( 586) GGCVSKPHSWPWQVSL  17
PLMN_ERIEU|Q29485  ( 584) GGCVAHPHSWPWQVSL  11

Q14520             ( 316) GGFKSTAGKHPWQASL  31
//
ID   kringle; BLOCK
AC   IPB000001D; distance from previous block=(5,53)
DE   Kringle domain
BL   CAC;  width=18; seqs=44; 99.5%=862; strength=1453
PLMN_BOVIN|P06868  ( 609) CGGTLISPKWVLTAAHCL  43
PLMN_ERIEU|Q29485  ( 607) CGGTLISPEWVVTAAHCL  42
PLMN_HUMAN|P00747  ( 607) CGGTLISPEWVLTAAHCL  36
PLMN_MACMU|P12545  ( 607) CGGTLISPEWVLTAAHCL  36
PLMN_MOUSE|P20918  ( 609) CGGTLIAPEWVLTAAHCL  40
PLMN_PIG|P06867    ( 587) CGGTLISPEWVLTAKHCL  61

Q64007             ( 520) CGGSLIKESWVLTARQCF  41
P70521             ( 512) CGGSLVKEQWVLTARQCI  49
Q90978             ( 517) CGGTLVKEEWVLTARQCF  45

Q91691             ( 509) CGGSLVKENWVISTRQCF  76
Q90865             ( 500) CGGSLVKEQWVISTQQCF  94
P70006             ( 510) CGGSLVKENWVISTRQCF  76

HGFA_HUMAN|Q04756  ( 432) CAGSLVHTCWVVSAAHCF  90
//
ID   LIPOYL; BLOCK
AC   IPB003016E; distance from previous block=(16,35)
DE   2-oxo acid dehydrogenases acyltransferase component lipoyl binding site
BL   DHG;  width=11; seqs=50; 99.5%=644; strength=1125
ODPX_HUMAN|O00330  ( 474) DSRVVDDELAT  42
O60221             ( 474) DSRVVDDELAT  42
P95595             ( 382) DHRIVDGKGAV  13
P74510             ( 404) DHRVIYGAHAA  32
Q9ZD20             ( 380) DHRVIDGAVSA   8
Q9Z8G6             ( 335) DHRLIDGKEAV   7

ODPX_YEAST|P16451  ( 155) PIKTVDGSQAN 100

ODB2_BACSU|P37942  ( 394) DHRVLDGLVCG  23
//
"""

add_test("format", format, data)

def test():
    test_list.test()

def dump(debug_level = 0):
    test_list.dump(debug_level)

import sys
def test_file():
    import os
    filename = \
             "/home/dalke/ftps/databases/blocks/unix/blocks-12.0/blocks.dat.Z"
    format2 = Martel.select_names(format, ())
    infile = os.popen("zcat " + filename)
    support.time_file(format, infile, debug_level = 0)

if __name__ == "__main__":
    #test_file()
    test()
    
