from Martel.formats.blocksplus import *

import support

test_list = support.Storage()
add_test = test_list.add_test
add_test_lines = test_list.add_test_lines

add_test_lines("ID line", ID_line, """\
ID   p99.1.146; BLOCK
ID   p99.1.2388; BLOCK
ID   DOMO2.0.DM00315; BLOCK
ID   Bact_microcomp; BLOCK
ID   arf; BLOCK
""")

add_test_lines("AC line", AC_line, """\
AC   BP01353A; distance from previous block=(108,881)
AC   BP01353B; distance from previous block=(-1,857)
AC   BP03191H; distance from previous block=(0,0)
""")

add_test_lines("DE line", DE_line, """\
DE   PROTEIN REPEAT PRECURSOR SI
DE   PROTEIN TRANSFERASE BIOSYNTHE
DE   PROTEIN ABC1 INTERGENIC REGION PRECURSOR MITOCHONDRION
DE   w INTEGRASE CP4-57 SYT P4.
""")

add_test_lines("BL line", BL_line, """\
BL   KLL;     width=6; seqs=49; 99.5%=449; strength=902
BL   RKQ;   width=31; seqs=6; 99.5%=1518; strength=1173
BL   EDN;  width=31; seqs=15; 99.5%=1385; strength=1374
BL   adapted;   width=14; seqs=38; 99.5%=712; strength=1290
""")

add_test_lines("data line", data_line, """\
DPSD_CLOPA|Q46192  (  41) KKKLFS  61
168K_RICTY|P96989  (  70) SVITANSNNAI  84
""")

add_test("cluster 1", cluster, """\
168K_RICTY|P96989  ( 911) GIDSMIN 100

190K_RICRI|P15921  (1673) GTTSFAN 100

FLIC_SHIFL|Q08860  (  80) GALSEIN  82
SLAP_CAUCR|P35828  ( 225) GALSTDN  92

SLAP_CAMFE|P35827  (  37) GVSSLAN  82
SLAP_LACAC|P35829  ( 177) GVASLTN  92
""")

add_test("record 1", record, """\
ID   p99.1.968; BLOCK
AC   BP00968A; distance from previous block=(7,85)
DE   PROTEIN LYASE PHYCOBILISOME PHY
BL   EAA;     width=5; seqs=25; 99.5%=401; strength=832
ADB_HUMAN|P21851   ( 360) EYATE  92

PECF_MASLA|P29730  (  69) KLAPA 100

YPGR_BACSU|P54169  (  86) ESAES  83

ADB1_RAT|P52303    ( 607) EAAPA  39
CPCE_ANASP|P07125  (  20) ELAIA  27
CPCE_FREDI|P07126  (  34) EQAIA  22
CPCE_PSEA9|Q52448  (  16) EQAIA  22
CPCE_SYNEL|P50037  (  45) ETATA  36
MPEU_SYNPY|Q02177  (  23) ELATA  36
//
""")

# Strange, but an extra newline is allowed!
add_test("record 2", record, """\
ID   p99.1.854; BLOCK
AC   BP00854A; distance from previous block=(10,352)
DE   PROTEIN ANTIGEN S-LAYER SURFA
BL   SNN;     width=11; seqs=6; 99.5%=628; strength=918
168K_RICTY|P96989  (  70) SVITANSNNAI  84

190K_RICRI|P15921  ( 353) STVTGNVGNTN  78

FLIC_SHIFL|Q08860  (  11) SLITQNNINKN  79

SLAP_CAMFE|P35827  ( 447) SASTLNLINSS  84

SLAP_CAUCR|P35828  (  83) STTNTNDLNDA 100

SLAP_LACAC|P35829  (  59) SAVAANTANNT  89

//
""")

# And two blank lines
add_test("record 3", record, """\
ID   p99.1.1106; BLOCK
AC   BP01106A; distance from previous block=(21,398)
DE   SIALIDASE NEURAMINIDASE HY
BL   ADG;     width=10; seqs=8; 99.5%=619; strength=914
GP85_TRYCR|Q03877  ( 230) AGVLMEDGTI  71

NANH_CLOSE|P29767  ( 399) ALYTTKDGTV  76

NANH_MICVI|Q02834  (  71) ALTVTPDGDL  84

NANH_SALTY|P29768  (  68) AAARSTDGGK 100

NANH_VIBCH|P37060  ( 384) AKIRIVDGAA  84

TCNA_TRYCR|P23253  (  22) AKYSVDDGET  88


NANH_CLOPE|P10481  ( 178) SGIVMDDGTI  60
NANH_CLOSO|P15698  ( 196) SGIVMSDGTI  65
//
""")

data = """\
                   Blocks+ Database, 15 November 2000
       Copyright 2000 by Fred Hutchinson Cancer Research Center
             1100 Fairview AV N, Seattle, WA 98109, USA

   Please cite: S Henikoff & JG Henikoff (1991) Automated assembly of
   protein blocks for database searching, Nucleic Acids Res. 19:6565-6572.
   ==========================================================================
ID   p99.1.146; BLOCK
AC   BP00146A; distance from previous block=(1,823)
DE   PROTEIN POLYMERASE RNA DNA-DIR
BL   KLL;     width=6; seqs=49; 99.5%=449; strength=902
DPSD_CLOPA|Q46192  (  41) KKKLFS  61

KSGA_MYCCA|P43038  (  29) KDQLII  36

NU2M_APIME|P34849  ( 252) KWNLIF  74

Y073_BORBU|O51100  (  28) KNNIML  40

YCX8_ASTLO|P14759  (   7) KAILEK  67

YKDA_MYCCA|P45615  ( 112) KIKVHL 100

YLI2_MYCHO|P43056  (   9) KKTIDV  74
YCX4_EUGGR|P30397  (  89) KRNLFL  18
YHI4_CAMJE|P45492  ( 317) KLNLDL  31
YMA6_PODAN|P15562  ( 221) KKSLEL  20
YS11_BORBU|P70838  ( 153) KVNLLL  30

EPIB_STAEP|P30195  ( 296) KNYLQI  47
SYD_BUCAP|P81432   ( 153) KNFLDI  31
//
ID   p99.1.146; BLOCK
AC   BP00146B; distance from previous block=(3,846)
DE   PROTEIN POLYMERASE RNA DNA-DIR
BL   LNK;     width=7; seqs=49; 99.5%=494; strength=927
BXCN_CLOBO|P46081  ( 207) LTYKYNK  21

DPOL_CBEPV|P30319  ( 364) LDTADNK  46

DPOM_ASCIM|P22374  ( 124) LNLTTNK  28

Y001_BORBU|O51035  (  17) LFCFQNK  34
YLI2_MYCHO|P43056  ( 198) LFYFDNK  21

RPC1_PLAFA|P27625  (1049) LLSYKNK  28
Y958_METJA|Q58368  ( 292) LLIWKNK  29
YY10_METJA|Q60309  (  88) LYSKKNK  22

YCF1_TOBAC|P12222  (1392) LPFQVNK  28
YCX8_ASTLO|P14759  (  17) LTNQVNK  18
//
ID   CCMBBIOGNSIS; BLOCK
AC   PR01414G; distance from previous block=(16,18)
DE   Cytochrome c-type biogenesis protein CcmB signature
BL   adapted;    width=24; seqs=10; 99.5%=1215; strength=1163
Q9Z3Z2             ( 193) LLWLATLTALAVTLAPFAIAAGLK  64
CCMB_RHOCA|P29960  ( 191) LAMLAGITAATVALVPFASAAAIR  75
CCMB_ECOLI|P33930  ( 193) LAILGALLAGTATLSPFATAAALR  58
O52687             ( 201) LAIIGAMLIGSLTLAPFAIGASLR  91
O33571             ( 191) FLLLGGITAGVAALLPFASAAAVR  76
CCMB_HAEIN|P45033  ( 193) LAILGAMMVGAVTLSPFAIAAALR  65
CCMB_PARDE|P52219  ( 190) LVFLAAITLATLALAFAAAAASVN 100
P95488             ( 192) LLWLASLTALAVTLAPFAIAAGLK  64
CCMB_BRAJA|P30964  ( 195) FSILCALSLVSLVIGPFAAAASLR  89
Q52735             ( 192) FLILIALTLFFAVIGPAAAALALR  99
//
"""

add_test("format", format, data)

def test():
    test_list.test()

def dump(debug_level = 0):
    test_list.dump(debug_level)

def test_file():
    import os
    filename = \
             "/home/dalke/ftps/databases/blocks/unix/blocksplus-15Nov00/blocks.dat.Z"
    format2 = Martel.select_names(format, ())
    infile = os.popen("zcat " + filename)
    support.time_file(format, infile, debug_level = 0)

if __name__ == "__main__":
    #test_file()
    test()
    
