from Martel.formats.embl65 import *

import support

test_list = support.Storage()
add_test = test_list.add_test
add_test_lines = test_list.add_test_lines

add_test_lines("ID line", ID_line, """\
ID   HSVNTRC2B  standard; DNA; HUM; 2468 BP.
ID   HSVWF201   standard; DNA; HUM; 89 BP.
""")

add_test_lines("AC line", AC_line, """\
AC   Z11740; S36048; S36051;
AC   M91370;
AC   M27592; M27593; M27595;
""")

add_test("AC block", AC_block, """\
AC   Z11740; S36048; S36051; M91370; M27592; M27593; M27595;
AC   U90287; U96079;
""")

add_test_lines("SV line", SV_line, """\
SV   Z11740.1
SV   X56734.1
""")

add_test_lines("DT created line", DT_created_line, """\
DT   15-APR-1992 (Rel. 31, Created)
DT   12-SEP-1991 (Rel. 29, Created)
""")

add_test_lines("DT updated line", DT_updated_line, """\
DT   26-JUN-1997 (Rel. 52, Last updated, Version 18)
DT   13-SEP-1993 (Rel. 37, Last updated, Version 8)
DT   02-JUL-1999 (Rel. 60, Last updated, Version 6)
""")

add_test_lines("DE line", DE_line, """\
DE   H.sapiens variable number tandem repeat (VNTR) locus DNA
DE   Homo sapiens voltage-operated calcium channel, alpha-1 subunit mRNA,
DE   complete cds.
""")

add_test("DE block 1", DE_block, """\
DE   H.sapiens variable number tandem repeat (VNTR) locus DNA
""")
add_test("DE block 2", DE_block, """\
DE   Homo sapiens voltage-operated calcium channel, alpha-1 subunit mRNA,
DE   complete cds.
""")

add_test_lines("KW line", KW_line, """\
KW   complement protein C2; variable number tandem repeat locus.
KW   .
KW   hypervariable region.
KW   exon trapping; Genome Survey Sequences; PKD1 gene;
KW   polycystic kidney disease.
""")

add_test("KW block 1", KW_block, """\
KW   hypervariable region.
""")
add_test("KW block 2", KW_block, """\
KW   exon trapping; Genome Survey Sequences; PKD1 gene;
KW   polycystic kidney disease.
""")

add_test("OS block 1", OS_block, """\
OS   Homo sapiens (human)
""")
add_test("OS block 2", OS_block, """\
OS   Mus musculus x Rattus norvegicus
""")
add_test("OS block 3", OS_block, """\
OS   Trifolium repens (white clover)
""")

add_test("OC block 1", OC_block, """\
OC   Eukaryota; Viridiplantae; Streptophyta; Embryophyta; Tracheophyta;
OC   euphyllophytes; Spermatophyta; Magnoliophyta; eudicotyledons; Rosidae;
OC   Fabales; Fabaceae; Papilionoideae; Trifolium.
""")
add_test("OC block 2", OC_block, """\
OC   Eukaryota; Metazoa; Chordata; Craniata; Vertebrata; Euteleostomi; Mammalia;
OC   Eutheria; Primates; Catarrhini; Hominidae; Homo.
""")

add_test("OG block 1", OG_block, """\
OG   Chloroplast
""")

add_test("reference 1", reference, """\
RN   [1]
RP   1-2468
RA   Zhu Z., Volanakis J.E.;
RT   "A variable number of tandem repeats (VNTR) locus within the human
RT   complement C2 gene is associated with a retroposon derived from az human
RT   endogenous retrovirus.";
RL   Unpublished.
""")

add_test_lines("DR line", DR_block, """\
DR   EPD; EP11159; HS_TNFB.
DR   GDB; 119009; AVP.
DR   GDB; 128528; IGHV@.
DR   IMGT/HLA; HLA00030; A*0224.
DR   IMGT/LIGM; M34927; M34927.
DR   REMTREMBL; CAA73052; CAA73052.
DR   RZPD; LLNLc131A09181; LLNLc131A09181.
DR   SPTREMBL; O95668; O95668.
DR   SWISS-PROT; Q13936; CCAC_HUMAN.
DR   TRANSFAC; R04677; HS$ERCC3_01.
DR   TRANSFAC; T01012; T01012.
""")

add_test("FH block", FH_block, """\
FH   Key             Location/Qualifiers
FH
""")

add_test("FT block 1", FT_block, """\
FT   source          1..2468
FT                   /chromosome="6"
FT                   /db_xref="taxon:9606"
FT                   /organism="Homo sapiens"
FT                   /clone="pS2.5"
FT                   /map="p21-23"
FT   repeat_region   1369..2041
FT                   /note="This is a SstI fragment from intron 3 of allele b of
FT                   the complement C2 gene,isolated from the cosmid S22A (Spies
FT                   et al., PNAS 86:8955,1989)"
""")

add_test("CC block 1", CC_block, """\
CC   Draft entry and computer-readable sequence for [1] kindly submitted
CC   by I.Craig, 29-MAR-1989.
""")
add_test("CC block 2", CC_block, """\
CC   Complete source information:
CC   Human fibroblast cell line IMR-90, cDNA to mRNA, clones
CC   lambda-VNR[10,11] [1]; clones lambda VRN[21,26] [3]; HUVE, cDNA to
CC   mRNA [2].
""")

add_test("SQ block 1", SQ_block, """\
SQ   Sequence 5717 BP; 1704 A; 1025 C; 1149 G; 1839 T; 0 other;
     ggctaccgct cccggcttgg cgtcccgcgc gcacttcggc gatggctttt ccgccgcggc        60
     gacggctgcg cctcggtccc cgcggcctcc cgcttcttct ctcgggactc ctgctacctc       120
     actgtaattc tgaatct                                                     5717
""")

add_test("SQ block 2", SQ_block, """\
SQ   Sequence 290 BP; 85 A; 59 C; 54 G; 92 T; 0 other;
     gatcctcttc atccacgata agacataaaa ggcttattgg tttgtgttgt gagtcactta        60
     atagacacct ttggtttgaa aaggtcaata ctgccaggaa tatttactgt ttgtcctggc       120
     tcaaacctga tagtaggata tttgaaagaa tttgtttttt aagagtctat ggtcaggagt       180
     tggccaaact gtaggctgac attcagaacc tgatatgata cacacacaca cacacacaca       240
     cacacacaca caccattttt ttaaggctac tctgttctct gttttggatc                  290
""")

add_test("record 1", record, """\
ID   HSVNTRC2B  standard; DNA; HUM; 2468 BP.
XX
AC   Z11740; S36048; S36051;
XX
SV   Z11740.1
XX
DT   15-APR-1992 (Rel. 31, Created)
DT   26-JUN-1997 (Rel. 52, Last updated, Version 18)
XX
DE   H.sapiens variable number tandem repeat (VNTR) locus DNA
XX
KW   complement protein C2; variable number tandem repeat locus.
XX
OS   Homo sapiens (human)
OC   Eukaryota; Metazoa; Chordata; Craniata; Vertebrata; Euteleostomi; Mammalia;
OC   Eutheria; Primates; Catarrhini; Hominidae; Homo.
XX
RN   [1]
RP   1-2468
RA   Zhu Z., Volanakis J.E.;
RT   "A variable number of tandem repeats (VNTR) locus within the human
RT   complement C2 gene is associated with a retroposon derived from az human
RT   endogenous retrovirus.";
RL   Unpublished.
XX
RN   [2]
RP   1-2468
RA   Campbell D.R.;
RT   ;
RL   Submitted (18-FEB-1992) to the EMBL/GenBank/DDBJ databases.
RL   Duncan R. Campbell Ph.D., MRC Immunochemistry Unit/Dept.Biochem., Oxford
RL   University, South Parks Road, Oxford, OX1 3AU, United, Kingdom
XX
RN   [3]
RP   1-2468
RX   MEDLINE; 92268827.
RA   Zhu Z.B., Hsieh S.L., Bentley D.R., Campbell R.D., Volanakis J.E.;
RT   "A variable number of tandem repeats locus within the human complement C2
RT   gene is associated with a retroposon derived from a human endogenous
RT   retrovirus";
RL   J. Exp. Med. 175:1783-1787(1992).
XX
FH   Key             Location/Qualifiers
FH
FT   source          1..2468
FT                   /chromosome="6"
FT                   /db_xref="taxon:9606"
FT                   /organism="Homo sapiens"
FT                   /clone="pS2.5"
FT                   /map="p21-23"
FT   repeat_region   1369..2041
FT                   /note="This is a SstI fragment from intron 3 of allele b of
FT                   the complement C2 gene,isolated from the cosmid S22A (Spies
FT                   et al., PNAS 86:8955,1989)"
XX
SQ   Sequence 2468 BP; 507 A; 683 C; 719 G; 559 T; 0 other;
     gagctcaagt gatcttccta cctcagcctc ctcagtagct gggaatgcag gcatgtgcca        60
     ccacgcctgg ccataagcac ttttgtcata gttattgctg cccctgtgaa tggtgagggg       120
     ctctgcttgg cagaagtagg gctcctagga ttccctggag ctgcatttgc ctgtgggttt       180
     gggagcttct tggatcatgg ttcttagcac atcatacaga agacacggag tccacaagat       240
     ggcaggacca ccttcaccta gtggcccaga ccatggatcc ccactcatgc ccttgggttt       300
     atcagaggga gaccgtggaa agagagggag agggagacca tggggagagg gtgagggaga      2460
     gggagctc                                                               2468
//
""")

# Note the 'XXX'
add_test("record 2", record, """\
ID   S40706     standard; XXX; HUM; 895 BP.
XX
AC   S40706;
XX
SV   S40706.1
XX
DT   16-FEB-1993 (Rel. 34, Created)
DT   27-MAR-1997 (Rel. 51, Last updated, Version 5)
XX
DE   GADD153=growth arrest and DNA-damage-inducible gene [human, Genomic/mRNA,
DE   895 nt].
XX
KW   .
XX
OS   Homo sapiens (human)
OC   Eukaryota; Metazoa; Chordata; Craniata; Vertebrata; Euteleostomi; Mammalia;
OC   Eutheria; Primates; Catarrhini; Hominidae; Homo.
XX
RN   [1]
RP   1-895
RX   MEDLINE; 92339899.
RA   Park JS., Luethy J.D., Wang M.G., Fargnoli J., Fornace A.J.Jr.,
RA   McBride O.W., Holbrook N.J.;
RT   "Isolation, characterization and chromosomal localization of the human
RT   GADD153 gene";
RL   Gene 116:259-267(1992).
XX
DR   SWISS-PROT; P35638; GA15_HUMAN.
DR   TRANSFAC; T01387; T01387.
XX
FH   Key             Location/Qualifiers
FH
FT   source          1..895
FT                   /db_xref="taxon:9606"
FT                   /organism="Homo sapiens"
FT   CDS             175..681
FT                   /codon_start=1
FT                   /db_xref="SWISS-PROT:P35638"
FT                   /note="Description: growth arrest and DNA-damage-inducible
FT                   gene; This sequence comes from Fig. 1"
FT                   /gene="GADD153"
FT                   /product="Gadd153"
FT                   /protein_id="AAB22646.1"
FT                   /translation="MAAESLPFSSDTVSWELEAWYEDLQEVLSSDENGGTYVSPPGNEE
FT                   EESKIFTTLDPASLAWLTEEEPEPAEVTSTSQSPHSPDSSQSSLAQEEEEEDQGRTRKR
FT                   KQSGHSPARAGKQRMKEKEQENERKVAQLAEENERLKQEIERLTREVEATRRALIDRMV
FT                   NLHQA"
XX
SQ   Sequence 895 BP; 265 A; 212 C; 238 G; 180 T; 0 other;
     agagacttaa gtctaaggca ctgagcgtat catgttaaag atgagcgggt ggcagcgaca        60
     gagccaaaat cagagctgga acctgaggag agagtgttca agaaggaagt gtatcttcat       120
     acatcaccac acctgaaagc agatgtgctt ttccagactg atccaactgc agagatggca       180
     gctgagtcat tgcctttctc ttcggacact gtcagctggg agctggaagc ctggtatgag       240
     gacctgcaag aggtcctgtc ttcagatgaa aatgggggta cctatgtttc acctcctgga       300
     aatgaagagg aagaatcaaa aatcttcacc actcttgacc ctgcttctct ggcttggctg       360
     actgaggagg agccagaacc agcagaggtc acaagcacct cccagagccc tcactctcca       420
     gattccagtc agagctccct ggctcaggag gaagaggagg aagaccaagg gagaaccagg       480
     aaacggaaac agagtggtca ttccccagcc cgggctggaa agcagcgcat gaaggagaaa       540
     gaacaggaga atgaaaggaa agtggcacag ctagctgaag agaatgaacg gctcaagcag       600
     gaaatcgagc gcctgaccag ggaagtagag gcgactcgcc gagctctgat tgaccgaatg       660
     gtgaatctgc accaagcatg aacaattggg agcatcagtc ccccacttgg gccacactac       720
     ccacctttcc cagaagtggc tactgactac cctctcacta gtgccaatga tgtgaccctc       780
     aatcccacat acgcaggggg aaggcttgga gtagacaaaa ggaaaggtct cagcttgtat       840
     atagagattg tacatttatt tattactgtc cctatctatt aaagtgactt tctat            895
//
""")

# This record has two organisms
add_test("record 3", record, """\
ID   S76114     standard; DNA; HUM; 569 BP.
XX
AC   S76114;
XX
SV   S76114.1
XX
DT   26-NOV-1993 (Rel. 37, Created)
DT   03-MAR-2000 (Rel. 62, Last updated, Version 3)
XX
DE   {right virus-host integration site} [hepatitis B virus HBV, Genomic, 569
DE   nt].
XX
KW   .
XX
OS   Homo sapiens (human)
OC   Eukaryota; Metazoa; Chordata; Craniata; Vertebrata; Euteleostomi; Mammalia;
OC   Eutheria; Primates; Catarrhini; Hominidae; Homo.
XX
OS   Hepatitis B virus
OC   Viruses; Retroid viruses; Hepadnaviridae; Orthohepadnavirus.
XX
RN   [1]
RC   GenBank staff at the National Library of Medicine created this entry [NCBI
RC   gibbsq 76114] from the original journal article. This sequence comes from
RC   fig2a.
RP   1-569
RX   MEDLINE; 92113569.
RA   Quade K., Saldanha J., Thomas H., Monjardino J.;
RT   "Integration of hepatitis B virus DNA through a mutational hot spot within
RT   the cohesive region in a case of hepatocellular carcinoma";
RL   J. Gen. Virol. 73(Pt 1):179-182(1992).
XX
FH   Key             Location/Qualifiers
FH
FT   source          1..569
FT                   /db_xref="taxon:9606"
FT                   /organism="Homo sapiens"
FT   source          1..396
FT                   /db_xref="taxon:10407"
FT                   /organism="Hepatitis B virus"
XX
SQ   Sequence 569 BP; 90 A; 191 C; 135 G; 151 T; 2 other;
     ggatcctgcg cgggacgtcc tttgtctacg tcccgtcggc gctgaatccc gcggacgacc        60
     cgtctcgggg ccgtttggga ctctaccgtc cccttcttca tctgccgttc cggccgacca       120
     cggggcgcac ctctctttac gcggtctccc cgtctgtgcc ttctcatctg ccggaccgtg       180
     tgcacttcgc ttcacctctg cacgtcgcat ggagaccacc gtgaacgccc gccaggtctt       240
     gcccaaggtc ttacataaga ggactcttgg actctcagca atgtcaacga cgaccttgag       300
     gcatacttca aagactgtgt gtttaaagac tgggaggagt tgggggagga gattaggtta       360
     aaggtctttg tactaggagg ctgtaggctg taggctatgt tgaaatatgt ttcttcttct       420
     tcctctttcc cttccccttc cccttccact cctcctccac ttcctcctcc tcctcctcct       480
     cccttctccc tccctcctcc ctcctcctcc tcctccttct aatcaagggg ggcctggtnn       540
     ggtggccaag ccgggaagaa aagtaaaag                                         569
//
""")


def test():
    test_list.test(debug_level = 0)

def dump(debug_level = 0):
    test_list.dump(debug_level)

import sys
def test_file():
    import os
    filename = "/home/dalke/ftps/databases/embl/release/hum7.dat.gz"
    format2 = Martel.select_names(format, ())
    infile = os.popen("zcat " + filename)
    support.time_file(format2, infile, debug_level = 0)

if __name__ == "__main__":
    #test_file()
    test()
    
