from Martel.formats.enzyme26 import *

import support

test_list = support.Storage()
add_test = test_list.add_test
add_test_lines = test_list.add_test_lines

add_test_lines("ID line", ID_line, """\
ID   1.1.1.1
ID   1.1.1.13
ID   2.1.1.120
ID   6.3.4.17
""")

add_test_lines("DE block", DE_block, """\
DE   Alcohol dehydrogenase.
DE   Alcohol dehydrogenase (NADP+).
""")

add_test("DE block", DE_block, """\
DE   Coenzyme-M-7-mercaptoheptanoylthreonine-phosphate-heterodisulfide
DE   hydrogenase.
""")

add_test_lines("nonterminal AN line", nonterminal_AN_line, """\
AN   O-glycosyl-oligosaccharide-glycoprotein N-acetylglucosaminyltransferase
AN   UDP-N-acetylmuramoyl-L-alanyl-D-glutamyl-L-lysyl-D-alanyl-D-alanine
AN   Test.With.Periods.Inside . The . string . but .. not ... at.the.end
""")

add_test_lines("terminal AN line", terminal_AN_line, """\
AN   Aldehyde reductase.
AN   Diacetyl reductase.
AN   Test.With.Periods.Inside . The . string . and .. at.the.end.
""")


add_test("AN subblock 1", AN_subblock, """\
AN   5-dehydroshikimate reductase.
""")

add_test("AN subblock 2", AN_subblock, """\
AN   O-glycosyl-oligosaccharide-glycoprotein N-acetylglucosaminyltransferase
AN   I.
""")

add_test("AN block 1", AN_block, """\
AN   5-dehydroshikimate reductase.
""")

add_test("AN block 2", AN_block, """\
AN   O-glycosyl-oligosaccharide-glycoprotein N-acetylglucosaminyltransferase
AN   II.
AN   Elongation 3beta-GalNAc-transferase.
""")

add_test("AN block 3", AN_block, """\
AN   Dolichyl-phosphate acetylglucosaminyltransferase.
AN   Dolichyl-phosphate N-acetylglucosaminyltransferase.
""")

add_test("AN block 4", AN_block, """\
AN   Hypoxanthine-guanine phosphoribosyltransferase.
AN   HGPRTase.
AN   IMP pyrophosphorylase.
AN   IMP diphosphorylase.
AN   Transphosphoribosidase.
AN   Guanine phosphoribosyltransferase.
""")

add_test("AN block 5", AN_block, """\
AN   UDP-N-acetylmuramoyl-L-alanyl-D-glutamyl-L-lysyl-D-alanyl-D-alanine
AN   synthetase.
AN   UDP-MurNAc-L-Ala-D-Glu-L-Lys:D-Ala-D-Ala ligase.
""")

add_test_lines("CA line", CA_line, """\
CA   An alcohol + NAD(+) = an aldehyde or ketone + NADH.
CA   L-homoserine + NAD(P)(+) = L-aspartate 4-semialdehyde + NAD(P)H.
""")

add_test("CA block", CA_block, """\
CA   Propane-1,2-diol 1-phosphate + NAD(+) = hydroxyacetone phosphate +
CA   NADH.
""")

add_test_lines("CF line", CF_line, """\
CF   Zinc or Iron.
CF   Potassium.
CF   Potassium or Ammonia; Manganese or Cobalt.
""")

# not actually present in release 26
add_test("CF block", CF_block, """\
CF   Potassium or Ammonia; Manganese or Cobalt; Heme-thiolate; FAD;
CF   Tungsten.
""")

add_test("comment block 1", comment_block, """\
CC   -!- Methyl viologen can act as acceptor.
""")

add_test("comment block 2", comment_block, """\
CC   -!- Methyl viologen can act as acceptor.
CC   -!- Also oxidizes N-furfurylformamide.
""")

add_test("comment block 3", comment_block, """\
CC   -!- Methyl viologen can act as acceptor.
CC   -!- In the reverse direction, non-activated acids are reduced by
CC       reduced viologens to aldehydes, but not to the corresponding
CC       alcohols.
""")

add_test("comment block 4", comment_block, """\
CC   -!- In the reverse direction, non-activated acids are reduced by
CC       reduced viologens to aldehydes, but not to the corresponding
CC       alcohols.
CC   -!- Methyl viologen can act as acceptor.
""")

add_test("comment block 5", comment_block, """\
CC   -!- The liver enzyme acts on enoyl-CoA derivatives of carbon chain
CC       length 4 to 16, with optimum activity on 2-hexenoyl-CoA.
CC   -!- In E.coli, cis-specific and trans-specific enzymes exist
CC       (cf. EC 1.3.1.37 and EC 1.3.1.38).
""")

add_test("comment block 6", comment_block, """\
CC   -!- In the reverse direction, a 2'-hydroxyisoflavone is reduced to an
CC       isoflavonone.
CC   -!- 2'-hydroxypseudobaptigenin also acts.
CC   -!- Involved in the biosynthesis of the pterocarpin phytoalexins
CC       medicarpin and maackiain.
""")


# The test ending in ',' is from 1.14.13.8
# The test ending in '0' is from 2.3.1.21
# The test with the extra space after MIM: is from 1.1.1.44
add_test_lines("DI line", DI_line, """\
DI   Pentosuria; MIM:260800.
DI   Sorbitol dehydrogenase deficiency; MIM:182500.
DI   Trimethylaminuria; MIM:602079,
DI   Lipid myopathy due to deficiency of CPT I; MIM:255120
DI   6-phosphogluconate dehydrogenase deficiency; MIM: 172200.
""")

add_test("DI block 1", DI_block, """\
DI   Lipid myopathy due to deficiency of CPT I; MIM:255120
DI   Lipid myopathy due to deficiency of CPT II; MIM:255110.
""")

add_test("DI block 2", DI_block, """\
DI   Gangliosidosis, generalized GM1; MIM:230500.
DI   Mucopolysaccharidosis IVB; MIM:253010.
""")

add_test_lines("PR line", PR_line, """\
PR   PROSITE; PDOC00676;
PR   PROSITE; PDOC00405;
PR   PROSITE; PDOC00405;
PR   PROSITE; PDOC00406;
PR   PROSITE; PDOC00405;
PR   PROSITE; PDOC00676;
""")

add_test_lines("DR line", DR_line, """\
DR   P46806, DHOM_MYCLE;  Q10601, DHOM_MYCTU;  P29365, DHOM_PSEAE;
DR   P52986, DHOM_SYNY3;  P31116, DHOM_YEAST;  P37144, DHON_METGL;
DR   Q48436, BUDC_KLEPN;  Q04520, BUDC_KLETE;
DR   P50173, GLDA_PSEPU;
DR   Q64442, DHSO_MOUSE;  P27867, DHSO_RAT  ;  Q59787, DHSO_RHOSH;
DR   P33010, TERD_PSESP;
""")

add_test("DR block", DR_block, """\
DR   P52986, DHOM_SYNY3;  P31116, DHOM_YEAST;  P37144, DHON_METGL;
DR   Q64442, DHSO_MOUSE;  P27867, DHSO_RAT  ;  Q59787, DHSO_RHOSH;
DR   P33010, TERD_PSESP;
""")

add_test("record 1", record, """\
ID   1.1.1.171
DE   Transferred entry: 1.5.1.20.
//
""")

add_test("record 2", record, """\
ID   1.1.1.29
DE   Glycerate dehydrogenase.
AN   Hydroxypyruvate reductase.
AN   Hydroxypyruvate dehydrogenase.
CA   (R)-glycerate + NAD(+) = hydroxypyruvate + NADH.
DI   Oxalosis II (glycericaciduria); MIM:260000.
PR   PROSITE; PDOC00063;
DR   P13443, DHGY_CUCSA;  P36234, DHGY_HYPME;  Q59516, DHGY_METEX;
//
""")

add_test("record 3", record, """\
ID   1.1.1.1
DE   Alcohol dehydrogenase.
AN   Aldehyde reductase.
CA   An alcohol + NAD(+) = an aldehyde or ketone + NADH.
CF   Zinc or Iron.
CC   -!- Acts on primary or secondary alcohols or hemiacetals.
CC   -!- The animal, but not the yeast, enzyme acts also on cyclic secondary
CC       alcohols.
PR   PROSITE; PDOC00058;
PR   PROSITE; PDOC00059;
PR   PROSITE; PDOC00060;
DR   P80222, ADH1_ALLMI;  P49645, ADH1_APTAU;  P06525, ADH1_ARATH;
DR   P41747, ADH1_ASPFL;  P12311, ADH1_BACST;  Q17334, ADH1_CAEEL;
DR   P43067, ADH1_CANAL;  P48814, ADH1_CERCA;  P23991, ADH1_CHICK;
DR   P23236, ADH1_DROHY;  P48586, ADH1_DROMN;  P09370, ADH1_DROMO;
DR   P22246, ADH1_DROMT;  P07161, ADH1_DROMU;  P12854, ADH1_DRONA;
DR   P08843, ADH1_EMENI;  P05336, ADH1_HORVU;  P20369, ADH1_KLULA;
DR   Q07288, ADH1_KLUMA;  P00333, ADH1_MAIZE;  P80512, ADH1_NAJNA;
DR   P20306, ADH1_ORYSA;  P12886, ADH1_PEA  ;  P14219, ADH1_PENAM;
DR   P25141, ADH1_PETHY;  O00097, ADH1_PICST;  Q03505, ADH1_RABIT;
DR   P22797, ADH1_RANPE;  P14673, ADH1_SOLTU;  P80338, ADH1_STRCA;
DR   P39462, ADH1_SULSO;  P13603, ADH1_TRIRP;  P00330, ADH1_YEAST;
DR   Q07264, ADH1_ZEALU;  P20368, ADH1_ZYMMO;  P42327, ADH2_BACST;
DR   O45687, ADH2_CAEEL;  P48815, ADH2_CERCA;  P27581, ADH2_DROAR;
DR   P25720, ADH2_DROBU;  P23237, ADH2_DROHY;  P48587, ADH2_DROMN;
DR   P09369, ADH2_DROMO;  P07160, ADH2_DROMU;  P25721, ADH2_DROMY;
DR   P24267, ADH2_DROWH;  P37686, ADH2_ECOLI;  P54202, ADH2_EMENI;
DR   Q24803, ADH2_ENTHI;  P10847, ADH2_HORVU;  P49383, ADH2_KLULA;
DR   P28032, ADH2_LYCES;  P04707, ADH2_MAIZE;  P18332, ADH2_ORYSA;
DR   P41681, ADH2_PERMA;  O13309, ADH2_PICST;  P14674, ADH2_SOLTU;
DR   P80468, ADH2_STRCA;  P00331, ADH2_YEAST;  P06758, ADH2_ZYMMO;
DR   P42328, ADH3_BACST;  P19631, ADH3_COTJA;  P25437, ADH3_ECOLI;
DR   P07754, ADH3_EMENI;  Q24857, ADH3_ENTHI;  P44557, ADH3_HAEIN;
DR   P10848, ADH3_HORVU;  P49384, ADH3_KLULA;  P39450, ADH3_PASPI;
DR   P14675, ADH3_SOLTU;  P50381, ADH3_SULSO;  P73138, ADH3_SYNY3;
DR   P07246, ADH3_YEAST;  P49385, ADH4_KLULA;  P10127, ADH4_YEAST;
DR   P38113, ADH5_YEAST;  P28332, ADH6_HUMAN;  P40394, ADH7_HUMAN;
DR   Q64437, ADH7_MOUSE;  P41682, ADH7_RAT  ;  Q64413, ADHA_GEOBU;
DR   Q64415, ADHA_GEOKN;  P07327, ADHA_HUMAN;  P00329, ADHA_MOUSE;
DR   P41680, ADHA_PERMA;  P06757, ADHA_RAT  ;  O31186, ADHA_RHIME;
DR   P25405, ADHA_UROHA;  P00325, ADHB_HUMAN;  P25406, ADHB_UROHA;
DR   P33744, ADHE_CLOAB;  P17547, ADHE_ECOLI;  P00327, ADHE_HORSE;
DR   Q09669, ADHF_SCHPO;  P00326, ADHG_HUMAN;  P81600, ADHH_GADMO;
DR   P72324, ADHI_RHOSH;  P81601, ADHL_GADMO;  P39451, ADHP_ECOLI;
DR   P08319, ADHP_HUMAN;  O46649, ADHP_RABIT;  O46650, ADHQ_RABIT;
DR   P00328, ADHS_HORSE;  Q96533, ADHX_ARATH;  Q17335, ADHX_CAEEL;
DR   P46415, ADHX_DROME;  P19854, ADHX_HORSE;  P11766, ADHX_HUMAN;
DR   P93629, ADHX_MAIZE;  P28474, ADHX_MOUSE;  P80360, ADHX_MYXGL;
DR   P81431, ADHX_OCTVU;  P93436, ADHX_ORYSA;  P80572, ADHX_PEA  ;
DR   O19053, ADHX_RABIT;  P12711, ADHX_RAT  ;  P79896, ADHX_SPAAU;
DR   P80467, ADHX_UROHA;  P14940, ADH_ALCEU ;  P30350, ADH_ANAPL ;
DR   Q00669, ADH_DROAD ;  P21518, ADH_DROAF ;  P25139, ADH_DROAM ;
DR   P48584, ADH_DROBO ;  Q00670, ADH_DROCR ;  P22245, ADH_DRODI ;
DR   P28483, ADH_DROER ;  P48585, ADH_DROFL ;  P51551, ADH_DROGR ;
DR   Q09009, ADH_DROGU ;  P51549, ADH_DROHA ;  P21898, ADH_DROHE ;
DR   Q07588, ADH_DROIM ;  Q27404, ADH_DROLA ;  P10807, ADH_DROLE ;
DR   P07162, ADH_DROMA ;  Q09010, ADH_DROMD ;  P00334, ADH_DROME ;
DR   Q00671, ADH_DROMM ;  Q00672, ADH_DRONI ;  P07159, ADH_DROOR ;
DR   P37473, ADH_DROPE ;  P23361, ADH_DROPI ;  P23277, ADH_DROPL ;
DR   P07158, ADH_DROPS ;  P07163, ADH_DROSI ;  P23278, ADH_DROSL ;
DR   Q03384, ADH_DROSU ;  P28484, ADH_DROTE ;  P51550, ADH_DROTS ;
DR   Q05114, ADH_DROWI ;  P26719, ADH_DROYA ;  P17648, ADH_FRAAN ;
DR   P26325, ADH_GADCA ;  P28469, ADH_MACMU ;  P48977, ADH_MALDO ;
DR   P14139, ADH_PAPHA ;  P25988, ADH_SCAAL ;  P00332, ADH_SCHPO ;
DR   P51552, ADH_ZAPTU ;  P32771, FADH_YEAST;  P71017, GBSB_BACSU;
DR   P33010, TERD_PSESP;
//
""")

add_test("format", format, """\
CC   -----------------------------------------------------------------------
CC
CC   ENZYME nomenclature database
CC
CC   -----------------------------------------------------------------------
CC   Release 26.0 of May 2000
CC   -----------------------------------------------------------------------
CC
CC   Amos Bairoch
CC   Swiss Institute of Bioinformatics (SIB)
CC   Centre Medical Universitaire (CMU)
CC   1, rue Michel Servet
CC   1211 Geneva 4
CC   Switzerland
CC
CC   Email: amos.bairoch@isb-sib.ch
CC   Telephone: +41-22-702 58 60
CC   Fax: +41-22-702 58 58
CC
CC   WWW server: http://www.expasy.ch/enzyme/
CC
CC   -----------------------------------------------------------------------
CC   This database is copyright from the Swiss Institute of Bioinformatics.
CC   There are  no restrictions  on  its use by any institutions as long as
CC   its content is in no way modified.
CC   -----------------------------------------------------------------------
//
ID   1.1.1.1
DE   Alcohol dehydrogenase.
AN   Aldehyde reductase.
CA   An alcohol + NAD(+) = an aldehyde or ketone + NADH.
CF   Zinc or Iron.
CC   -!- Acts on primary or secondary alcohols or hemiacetals.
CC   -!- The animal, but not the yeast, enzyme acts also on cyclic secondary
CC       alcohols.
PR   PROSITE; PDOC00058;
PR   PROSITE; PDOC00059;
PR   PROSITE; PDOC00060;
DR   P80222, ADH1_ALLMI;  P49645, ADH1_APTAU;  P06525, ADH1_ARATH;
DR   P41747, ADH1_ASPFL;  P12311, ADH1_BACST;  Q17334, ADH1_CAEEL;
DR   P43067, ADH1_CANAL;  P48814, ADH1_CERCA;  P23991, ADH1_CHICK;
DR   P23236, ADH1_DROHY;  P48586, ADH1_DROMN;  P09370, ADH1_DROMO;
DR   P22246, ADH1_DROMT;  P07161, ADH1_DROMU;  P12854, ADH1_DRONA;
DR   P08843, ADH1_EMENI;  P05336, ADH1_HORVU;  P20369, ADH1_KLULA;
DR   Q07288, ADH1_KLUMA;  P00333, ADH1_MAIZE;  P80512, ADH1_NAJNA;
DR   P20306, ADH1_ORYSA;  P12886, ADH1_PEA  ;  P14219, ADH1_PENAM;
DR   P25141, ADH1_PETHY;  O00097, ADH1_PICST;  Q03505, ADH1_RABIT;
DR   P22797, ADH1_RANPE;  P14673, ADH1_SOLTU;  P80338, ADH1_STRCA;
DR   P39462, ADH1_SULSO;  P13603, ADH1_TRIRP;  P00330, ADH1_YEAST;
DR   Q07264, ADH1_ZEALU;  P20368, ADH1_ZYMMO;  P42327, ADH2_BACST;
DR   O45687, ADH2_CAEEL;  P48815, ADH2_CERCA;  P27581, ADH2_DROAR;
DR   P25720, ADH2_DROBU;  P23237, ADH2_DROHY;  P48587, ADH2_DROMN;
DR   P09369, ADH2_DROMO;  P07160, ADH2_DROMU;  P25721, ADH2_DROMY;
DR   P24267, ADH2_DROWH;  P37686, ADH2_ECOLI;  P54202, ADH2_EMENI;
DR   Q24803, ADH2_ENTHI;  P10847, ADH2_HORVU;  P49383, ADH2_KLULA;
DR   P28032, ADH2_LYCES;  P04707, ADH2_MAIZE;  P18332, ADH2_ORYSA;
DR   P41681, ADH2_PERMA;  O13309, ADH2_PICST;  P14674, ADH2_SOLTU;
DR   P80468, ADH2_STRCA;  P00331, ADH2_YEAST;  P06758, ADH2_ZYMMO;
DR   P42328, ADH3_BACST;  P19631, ADH3_COTJA;  P25437, ADH3_ECOLI;
DR   P07754, ADH3_EMENI;  Q24857, ADH3_ENTHI;  P44557, ADH3_HAEIN;
DR   P10848, ADH3_HORVU;  P49384, ADH3_KLULA;  P39450, ADH3_PASPI;
DR   P14675, ADH3_SOLTU;  P50381, ADH3_SULSO;  P73138, ADH3_SYNY3;
DR   P07246, ADH3_YEAST;  P49385, ADH4_KLULA;  P10127, ADH4_YEAST;
DR   P38113, ADH5_YEAST;  P28332, ADH6_HUMAN;  P40394, ADH7_HUMAN;
DR   Q64437, ADH7_MOUSE;  P41682, ADH7_RAT  ;  Q64413, ADHA_GEOBU;
DR   Q64415, ADHA_GEOKN;  P07327, ADHA_HUMAN;  P00329, ADHA_MOUSE;
DR   P41680, ADHA_PERMA;  P06757, ADHA_RAT  ;  O31186, ADHA_RHIME;
DR   P25405, ADHA_UROHA;  P00325, ADHB_HUMAN;  P25406, ADHB_UROHA;
DR   P33744, ADHE_CLOAB;  P17547, ADHE_ECOLI;  P00327, ADHE_HORSE;
DR   Q09669, ADHF_SCHPO;  P00326, ADHG_HUMAN;  P81600, ADHH_GADMO;
DR   P72324, ADHI_RHOSH;  P81601, ADHL_GADMO;  P39451, ADHP_ECOLI;
DR   P08319, ADHP_HUMAN;  O46649, ADHP_RABIT;  O46650, ADHQ_RABIT;
DR   P00328, ADHS_HORSE;  Q96533, ADHX_ARATH;  Q17335, ADHX_CAEEL;
DR   P46415, ADHX_DROME;  P19854, ADHX_HORSE;  P11766, ADHX_HUMAN;
DR   P93629, ADHX_MAIZE;  P28474, ADHX_MOUSE;  P80360, ADHX_MYXGL;
DR   P81431, ADHX_OCTVU;  P93436, ADHX_ORYSA;  P80572, ADHX_PEA  ;
DR   O19053, ADHX_RABIT;  P12711, ADHX_RAT  ;  P79896, ADHX_SPAAU;
DR   P80467, ADHX_UROHA;  P14940, ADH_ALCEU ;  P30350, ADH_ANAPL ;
DR   Q00669, ADH_DROAD ;  P21518, ADH_DROAF ;  P25139, ADH_DROAM ;
DR   P48584, ADH_DROBO ;  Q00670, ADH_DROCR ;  P22245, ADH_DRODI ;
DR   P28483, ADH_DROER ;  P48585, ADH_DROFL ;  P51551, ADH_DROGR ;
DR   Q09009, ADH_DROGU ;  P51549, ADH_DROHA ;  P21898, ADH_DROHE ;
DR   Q07588, ADH_DROIM ;  Q27404, ADH_DROLA ;  P10807, ADH_DROLE ;
DR   P07162, ADH_DROMA ;  Q09010, ADH_DROMD ;  P00334, ADH_DROME ;
DR   Q00671, ADH_DROMM ;  Q00672, ADH_DRONI ;  P07159, ADH_DROOR ;
DR   P37473, ADH_DROPE ;  P23361, ADH_DROPI ;  P23277, ADH_DROPL ;
DR   P07158, ADH_DROPS ;  P07163, ADH_DROSI ;  P23278, ADH_DROSL ;
DR   Q03384, ADH_DROSU ;  P28484, ADH_DROTE ;  P51550, ADH_DROTS ;
DR   Q05114, ADH_DROWI ;  P26719, ADH_DROYA ;  P17648, ADH_FRAAN ;
DR   P26325, ADH_GADCA ;  P28469, ADH_MACMU ;  P48977, ADH_MALDO ;
DR   P14139, ADH_PAPHA ;  P25988, ADH_SCAAL ;  P00332, ADH_SCHPO ;
DR   P51552, ADH_ZAPTU ;  P32771, FADH_YEAST;  P71017, GBSB_BACSU;
DR   P33010, TERD_PSESP;
//
ID   1.1.1.2
DE   Alcohol dehydrogenase (NADP+).
AN   Aldehyde reductase (NADPH).
CA   An alcohol + NADP(+) = an aldehyde + NADPH.
CF   Zinc.
CC   -!- Some members of this group oxidize only primary alcohols; others act
CC       also on secondary alcohols.
CC   -!- May be identical with EC 1.1.1.19, EC 1.1.1.33 and EC 1.1.1.55.
CC   -!- A-specific with respect to NADPH.
PR   PROSITE; PDOC00061;
DR   P35630, ADH1_ENTHI;  O57380, ADH4_RANPE;  P25984, ADH_CLOBE ;
DR   P75214, ADH_MYCPN ;  P31975, ADH_MYCTU ;  P14941, ADH_THEBR ;
DR   P14550, ALDX_HUMAN;  P50578, ALDX_PIG  ;  P51635, ALDX_RAT  ;
DR   P27800, ALDX_SPOSA;
//
ID   1.1.1.3
DE   Homoserine dehydrogenase.
CA   L-homoserine + NAD(P)(+) = L-aspartate 4-semialdehyde + NAD(P)H.
CC   -!- The yeast enzyme acts most rapidly with NAD(+); Neurospora enzyme
CC       with NADP(+). Enzyme from E.coli is a multifunctional protein, which
CC       also catalyses the reaction of EC 2.7.2.4.
PR   PROSITE; PDOC00800;
DR   P00561, AK1H_ECOLI;  P27725, AK1H_SERMA;  P00562, AK2H_ECOLI;
DR   P49079, AKH1_MAIZE;  P49080, AKH2_MAIZE;  P37142, AKH_DAUCA ;
DR   P44505, AKH_HAEIN ;  P19582, DHOM_BACSU;  P08499, DHOM_CORGL;
DR   P56429, DHOM_HELPY;  P52985, DHOM_LACLA;  P37143, DHOM_METGL;
DR   P46806, DHOM_MYCLE;  Q10601, DHOM_MYCTU;  P29365, DHOM_PSEAE;
DR   P52986, DHOM_SYNY3;  P31116, DHOM_YEAST;  P37144, DHON_METGL;
//
""")

def test():
    test_list.test(debug_level = 1)

def dump(debug_level = 0):
    test_list.dump(debug_level)

def time_file():
    filename = "/home/dalke/ftps/databases/enzyme/enzyme.dat"
    infile = open(filename)
    support.time_file(format, infile, debug_level = 0)

if __name__ == "__main__":
    #dump()
    #time_file()
    test()
