from Martel.formats.primers import *

import support

test_list = support.Storage()
add_test = test_list.add_test
add_test_lines = test_list.add_test_lines

add_test_lines("access", access, """\
ACCESS  PR00001
ACCESS  PR00061
""")

# Note: the second line has two spaces
add_test_lines("sep", sep, """\
XXXXXX
XXXXXX  
""")

add_test_lines("date (created)", datein_created, """\
DATEIN  7-FEB-1997  (created)
DATEIN  30-NOV-1995  (created)
""")

add_test("target 1", target, """\
TARGET  miniswine MHC class I gene - PD1 expressed in transgenic mice
""")
add_test("target 2", target, """\
TARGET  Mouse MHC class I gene - H-2Kd, derived from clone pH2D33,
TARGET  expressed in transgenic mice
""")

add_test_lines("numref", numref, """\
NUMREF  position 1 on a cDNA
NUMREF  EMBL/Genbank/DDBJ:D28581
NUMREF  Y00052 M19533 X52803 X17105
NUMREF  Position 1 on 16S RNA to position 742 on 23S RNA
""")

add_test("numref block", numref, """\
NUMREF  Relative to 3' end of Intron 21 (forward) and to 5' end of Intron
NUMREF  23 (reverse).
""")

add_test_lines("ospecs", ospecs, """\
OSPECS  SUS SCROFA (PIG)
OSPECS  HOMO SAPIENS (HUMAN); RATTUS NORVEGICUS (RAT)
""")

add_test_lines("spapll", spapll, """\
SPAPLL  Amplifies human target in human-rodent somatic cell hybrids
SPAPLL  Detection of a transgene
""")

add_test_lines("lncdna", lncdna, """\
LNCDNA  217
LNCDNA  variable (87bp without insert)
""")

add_test_lines("lngdna", lngdna, """\
LNGDNA  122
LNGDNA  230 bp
LNGDNA  ~500bp (12s); ~800 bp (16s); ~1200 (18s)
LNGDNA  5.75 Kb
LNGDNA  340  bp
""")

add_test_lines("fpname", fpname, """\
FPNAME  PD1X2P132
FPNAME  D30.31
FPNAME  Ac1382Forward
FPNAME  primer_1
""")

add_test_lines("fpseqn", fpseqn, """\
FPSEQN  TAT CAC CCC AGA TCT CAA GTT GAT     24
FPSEQN  CTG AAG CTG CCA ATT CC     17
""")

add_test_lines("fflank", fflank, """\
FFLANK  643
FFLANK  -45
FFLANK  218 (Y00118)
""")

add_test_lines("frestr", frestr, """\
FRESTR  BamH
""")

# add_test_lines("fmutat", fmutat, """\
# """)

add_test_lines("rpname", rpname, """\
RPNAME  H2KdX5AS1020
RPNAME  D30.16
RPNAME  primer_2
""")

add_test_lines("rpseqn", rpseqn, """\
RPSEQN  GGA GGA TAG AGA CAC AC     17
RPSEQN  ATG TTC TTC TTG GGC CTT ATC TAT TCC A     28
""")

add_test_lines("rflank", rflank, """\
RFLANK  7
RFLANK  291 (Y00118); 41 (J02460)
RFLANK  GGAAGGGCATTAAGGTCATTA
""")

add_test_lines("rrestr", rrestr, """\
RRESTR  Kpn I
RRESTR  Mlu
""")

# add_test_lines("rmutat", rmutat, """\
# """)

add_test_lines("tcycle", tcycle, """\
TCYCLE  MJ Research; minicycler
TCYCLE  Perkin-Elmer; DNA thermal cycler
TCYCLE  Applied Biosystems; GeneAmp PCR system 9600
""")

add_test_lines("probin", probin, """\
PROBIN  YES
PROBIN  NO
""")

add_test_lines("hotstr", hotstr, """\
HOTSTR  NO
HOTSTR  YES
""")

add_test_lines("idenat", idenat, """\
IDENAT  92; 300
IDENAT  95; 30
""")

add_test_lines("denatr", denatr, """\
DENATR  94; 45
""")

add_test_lines("anneal", anneal, """\
ANNEAL  57; 45
ANNEAL  55; 160
""")

add_test_lines("tchdwn", tchdwn, """\
TCHDWN  0.4; 2
""")

add_test_lines("extend", extend, """\
EXTEND  72; 30
EXTEND  72; 120
""")

# add_test_lines("prgrss", prgrss, """\
# """)

add_test_lines("finext", finext, """\
FINEXT  72; 10
FINEXT  72; 300
""")

add_test_lines("cycles", cycles, """\
CYCLES  35
""")

add_test_lines("rxnvol", rxnvol, """\
RXNVOL  25
""")

add_test_lines("polymr", polymr, """\
POLYMR  Taq; Apligene; 0.5
POLYMR  Taq; Perkin Elmer AmpliTaq; 2.5
POLYMR  Pfu; Stratagene; 2.5
POLYMR  Taq; Pharmacia; 1
POLYMR  Taq; Tth+; 0.3
""")

add_test("buffer 1", buffer, """\
BUFFER  Promega
""")
add_test("buffer 2", buffer, """\
BUFFER  10 x AmpliTaq (Perkin Elmer)
""")
add_test("buffer 3", buffer, """\
BUFFER  The standard Taq (200 mM Tris-HCL pH 8.4, 500 mM KCL) polymerase
BUFFER  buffer from GibcoBRL was used at a 1X concentration
""")

add_test_lines("dntpcn", dntpcn, """\
DNTPCN  400
DNTPCN  0.1
""")

add_test_lines("primcn", primcn, """\
PRIMCN  2
PRIMCN  1.5
""")

add_test_lines("mgconc", mgconc, """\
MGCONC  1.5
MGCONC  20
""")

add_test_lines("aditiv", aditiv, """\
ADITIV  BSA 1%; DMSO 5%
ADITIV  Cosmid;
""")

add_test("source 1", source, """\
SOURCE  5ul of blood + 1ml of DDW + 10% Chelex X-100 (BioRad). Boil 20
SOURCE  minutes. Take 5ul of supernatant / reaction
""")
add_test("source 2", source, """\
SOURCE  Cosmid Nucleobond preparation; 10ng
""")
add_test("source 3", source, """\
SOURCE  Germinating embryos, Doyle and Doyle (1990), 25ng
""")

add_test_lines("dbxref", dbxref, """\
DBXREF  EMBL/Genbank/DDBJ: X95489; X95490; X95491; X95492; X95493
DBXREF  EMBL/Genbank/DDBJ:M21057; M19649;
DBXREF  EMBL/Genbank/DDBJ:S67722
DBXREF  EMBL/Genbank/DDBJ:X95404;
DBXREF  EMBL/Genbank/DDBJ:Y00052; M19533; X52803; X17105;
DBXREF  PIR:A02204;
DBXREF  SWISS-PROT: P43118;
DBXREF  SWISS-PROT:P01902;
""")

add_test_lines("cntnam", cntnam, """\
CNTNAM  Marc Lipinski
CNTNAM  MARC LIPINSKI
CNTNAM  Clemens Suter-Crazzolara
CNTNAM  Edmundo Castro (submits) Dr. Gorden Glazner (designer)
CNTNAM  motooki ashihara
CNTNAM  dennis S SALONGA
""")

add_test_lines("cntins", cntins, """\
CNTINS  EMBL outstation, the EBI, User support
CNTINS  Forest tree breeding institute, National research council
CNTINS  Forest tree breeding institute, National research council
CNTINS  helix research institute, the third division
""")

add_test("cntadr 1", cntadr, """\
CNTADR  5929 Life Science Building, 405 Hilgard Ave., LA Ca 90095, USA
""")
add_test("cntadr 2", cntadr, """\
CNTADR  5929 Life Science Building, 405 Hilgard Ave WLA, Ca 90095, USA
""")
add_test("cntadr 3", cntadr, """\
CNTADR  5929 Life Sciences Building, University of California, Los
CNTADR  Angeles, CA, 90095, USA
""")

add_test_lines("cnteml", cnteml, """\
CNTEML  no_uce@here.there
""")

add_test_lines("cnttel", cnttel, """\
CNTTEL  310-2064123
CNTTEL  +33 1 4559 49 23
CNTTEL  +49-211-8114923
""")

add_test_lines("cntfax", cntfax, """\
CNTFAX  +27-12-808-1423
CNTFAX  310-206-9123
CNTFAX  310-2069123
CNTFAX  +33 1 4559 64 23
""")

add_test("refaut 1", refaut, """\
REFAUT  Shomer, B.,(Thesis)
""")

add_test("refaut 2", refaut, """\
REFAUT  Lorain S., Demczuk S., Lamour V., Toth S., Aurias A., Roe B.A.,
REFAUT  Lipinski M.
""")

add_test("refaut 3", refaut, """\
REFAUT  Adams JW., Migita DS., Yu MK., Young R., Hellickson MS.,
REFAUT  Castro-Vargas FE., Domingo JD., Lee PH., Bui JS., Henderson SA.
""")

add_test("refttl 1", refttl, """\
REFTTL  Prostaglandin F2 alpha Stimulates Hypertrophic Growth of Cultured
REFTTL  Neonatal Rat Ventricular Myocytes
""")
add_test("refttl 2", refttl, """\
REFTTL  (Unpublished)
""")

add_test_lines("refsrc", refsrc, """\
REFSRC  Tel-Aviv University, Ph.D. thesis (1995)
REFSRC  Genome Research
REFSRC  J. Biol. Chem. 271:1179-1186 (1996)
REFSRC  AIDS 7 (suppl 2):59-64 (1993)
""")

add_test_lines("refxrf", refxrf, """\
REFXRF  MEDLINE; 95210610.
""")

add_test("remark 1", remark, """\
REMARK  NOTE: Base number 7 in primer_2 has been designed to mismatch the
REMARK  original sequence in K03455. This reflects the more frequent
REMARK  appearance of T in the consensus 1.
""")
add_test("remark 2", remark, """\
REMARK  Internal BamHI site is present in target sequence
""")

add_test("end", end, """\
//
""")

add_test("format", format, """\
ACCESS  PR00001
XXXXXX  
DATEIN  9-NOV-1995  (created)
XXXXXX  
TARGET  miniswine MHC class I gene - PD1 expressed in transgenic mice
XXXXXX  
NUMREF  position 1 on a cDNA
XXXXXX  
OSPECS  SUS SCROFA (PIG)
XXXXXX  
SPAPLL  Detection of a transgene
XXXXXX  
LNCDNA  172
XXXXXX  
FPNAME  PD1X2P132
FPSEQN  CTC TCG CTT CAT CGC CGT     18
FFLANK  132
XXXXXX  
RPNAME  PD1X2AS265
RPSEQN  CCG TAA GTC TGT GCG GTT TCC     21
RFLANK  265
XXXXXX  
TCYCLE  MJ Research; minicycler
PROBIN  YES
HOTSTR  NO
XXXXXX  
IDENAT  92; 300
DENATR  92; 30
ANNEAL  60; 30
EXTEND  72; 30
FINEXT  72; 10
CYCLES  35
XXXXXX  
RXNVOL  50
POLYMR  Taq; Apligene; 0.5
BUFFER  Apligene
DNTPCN  40
PRIMCN  1
ADITIV  BSA 1%; DMSO 5%
SOURCE  5ul of blood + 1ml of DDW + 10% Chelex X-100 (BioRad). Boil 20
SOURCE  minutes. Take 5ul of supernatant / reaction
XXXXXX  
DBXREF  EMBL/Genbank/DDBJ:M21057; M19649;
XXXXXX  
CNTNAM  Benny Shomer
CNTINS  EMBL outstation, the EBI, User support
CNTADR  Hinxton Hall, Hinxton, Cambridge, CB10 1RQ, UK
CNTEML  bshomer@ebi.ac.uk
CNTTEL  +44 1223 494437
CNTFAX  +44 1223 494468
XXXXXX  
REFAUT  Shomer B., (Thesis)
REFTTL  Expression of MHC antigens on the trophoblast tissue
REFSRC  Tel-Aviv University, Ph.D. thesis (1995)
//
ACCESS  PR00002
XXXXXX  
DATEIN  9-NOV-1995  (created)
XXXXXX  
TARGET  Mouse MHC class I gene - H-2Kd, derived from clone pH2D33,
TARGET  expressed in transgenic mice
XXXXXX  
NUMREF  position 1 on a cDNA
XXXXXX  
OSPECS  MUS MUSCULUS (MOUSE)
XXXXXX  
SPAPLL  Detection of a transgene
XXXXXX  
LNCDNA  377
XXXXXX  
FPNAME  H2KdX4P643
FPSEQN  TAT CAC CCC AGA TCT CAA GTT GAT     24
FFLANK  643
XXXXXX  
RPNAME  H2KdX5AS1020
RPSEQN  CTG TGT TCC TTC TCA TCT TC     20
RFLANK  1020
XXXXXX  
TCYCLE  MJ Research; minicycler
PROBIN  YES
HOTSTR  NO
XXXXXX  
IDENAT  92; 300
DENATR  92; 30
ANNEAL  52; 30
EXTEND  72; 45
FINEXT  72; 10
CYCLES  35
XXXXXX  
RXNVOL  50
POLYMR  Taq; Apligene; 0.5
BUFFER  Apligene
DNTPCN  40
PRIMCN  1
ADITIV  BSA 1%; DMSO 5%
SOURCE  5ul of blood + 1ml of DDW + 10% Chelex X-100 (BioRad). Boil 20
SOURCE  minutes. Take 5ul of supernatant / reaction
XXXXXX  
DBXREF  EMBL/Genbank/DDBJ:J00402;
DBXREF  SWISS-PROT:P01902;
DBXREF  PIR:A02204;
XXXXXX  
CNTNAM  Benny Shomer
CNTINS  EMBL outstation, the EBI, User support
CNTADR  Hinxton Hall, Hinxton, Cambridge, CB10 1RQ, UK
CNTEML  bshomer@ebi.ac.uk
CNTTEL  +44 1223 494437
CNTFAX  +44 1223 494468
XXXXXX  
REFAUT  Shomer, B.,(Thesis)
REFTTL  Expression of MHC antigens on the trophoblast tissue
REFSRC  Tel-Aviv University, Ph.D. thesis (1995)
//
""")

def test():
    test_list.test(debug_level = 1)

def dump(debug_level = 0):
    test_list.dump(debug_level)

def time_file():
    filename = "/home/dalke/ftps/databases/primers/primers.dat"
    infile = open(filename)
    support.time_file(format, infile)

if __name__ == "__main__":
    #dump()
    #time_file()
    test()
