from Martel.formats.prodoc16 import *

import support

test_list = support.Storage()
add_test = test_list.add_test
add_test_lines = test_list.add_test_lines

add_test_lines("pdoc_start", prodoc_start, """\
{PDOC00000}
{PDOC00887}
""")

add_test_lines("prosite_ref", prosite_ref, """\
{PS01152; HESB}
{PS00003; SULFATION}
{PS00888; CNMP_BINDING_1}
""")

add_test_lines("begin", begin, """\
{BEGIN}
""")

add_test("title 1", title, """\
***********************************************************
* Cyclic nucleotide-binding domain signatures and profile *
***********************************************************
""")

add_test("title 2", title, """\
**********************
* CUB domain profile *
**********************
""")

add_test("title 3", title, """\
************************************************************************
* Binding-protein-dependent transport systems inner membrane component *
* signature                                                            *
************************************************************************
""")

add_test("text 1", text, """\
The CUB  domain  [1,2,E1]  is  an  extracellular  domain  of approximately 110
residues which  is  found  in  functionally  diverse,  mostly  developmentally
regulated proteins.
""")

add_test("text 2", text, """\
Proteins that have been found to contain the CUB domain are listed below.
""")

add_test("text 3", text, """\
Have you seen <PDOC12345> or (EC 1.2.3.4) or (EC 3.2.1.-)?  Didn't think so.
""")

add_test_lines("update info", update_info, """\
-Last update: November 1995 / Pattern and text revised.
-Last update: November 1995 / Text revised.
""")

add_test("expert info 1", expert_info, """\
-Expert(s) to contact by email:
           Koonin E.V.; abcdef@ncbi.nlm.nih.gov
""")
add_test("expert info 2", expert_info, """\
-Expert(s) to contact by email:
           Cox J.A.; xyz@sc2a.unige.ch
           Kretsinger R.H.; klm5i@virginia.edu
""")
add_test("generic info 1", generic_info, """\
-Other sequence(s) detected in SWISS-PROT: NONE.
""")
add_test("generic info 2", generic_info, """\
-Consensus pattern: T-x-[GS]-x(2)-H-[LIVMF]-x(3)-E-[DE]-x-P
                    [H is a copper ligand]
""")
add_test("generic info 3", generic_info, """\
-Note: in positions 6 and 7 of the pattern all known  sequences have Asn-(Val/
 Ile) with the  exception of GR from plant chloroplasts and from cyanobacteria
 which have Ile-Arg [7].
""")


add_test("footnote 1", footnote, """\
[ 1] Isaaks N.W.
     Curr. Opin. Struct. Biol. 5:391-395(1995).
""")

# But some records don't have the extra space
add_test("footnote 2", footnote, """\
[1] Chen L.-S.K., Lo C.F., Numann R., Cuddy M.
    Genomics 41:435-443(1997).
""")


add_test("footnote 3", footnote, """\
[ 8] Selander-Sunnerhagen M., Ullner M., Persson E., Teleman O., Stenflo J.,
     Drakenberg T.
     J. Biol. Chem. 267:19642-19649(1992).
""")

add_test("footnote 4", footnote, """\
[10] Hvarregaard J., Andersen M.H., Berglund L., Rasmussen J.T., Petersen T.E.
     Eur. J. Biochem. 240:628-636(1996).
""")

add_test("footnote 5", footnote, """\
[E1] http://www.expasy.ch/linder/HELICASES_TEXT.html
""")


add_test("end", end, """\
{END}
""")

add_test("record 1", record, """\
{PDOC00005}
{PS00005; PKC_PHOSPHO_SITE}
{BEGIN}
*****************************************
* Protein kinase C phosphorylation site *
*****************************************

In vivo, protein kinase C  exhibits  a  preference  for the phosphorylation of
serine or  threonine residues found close to a C-terminal basic residue [1,2].
The presence  of  additional   basic residues at the  N- or C-terminal of  the
target amino acid enhances the Vmax and Km of the phosphorylation reaction.

Blah blah blah to see if the EC check works:
 - G protein gamma subunits (see <PDOC01002>).
 - 2',3'-cyclic nucleotide 3'-phosphodiesterase (EC 3.1.4.37).
 - Rhodopsin-sensitive  cGMP 3',5'-cyclic  phosphodiesterase  alpha  and  beta
   chains (EC 3.1.4.17).
 - Rhodopsin kinase (EC 2.7.1.125).


-Consensus pattern: [ST]-x-[RK]
                    [S or T is the phosphorylation site]
-Last update: June 1988 / First entry.

[ 1] Woodget J.R., Gould K.L., Hunter T.
     Eur. J. Biochem. 161:177-184(1986).
[ 2] Kishimoto A., Nishiyama K., Nakanishi H., Uratsuji Y., Nomura H.,
     Takeyama Y., Nishizuka Y.
     J. Biol. Chem. 260:12492-12499(1985).
{END}
""")

add_test("record 2", record, """\
{PDOC00010}
{PS00010; ASX_HYDROXYL}
{BEGIN}
***************************************************
* Aspartic acid and asparagine hydroxylation site *
***************************************************

Post-translational  hydroxylation of aspartic acid or  asparagine [1] to  form
erythro-beta-hydroxyaspartic acid  or erythro-beta-hydroxyasparagine  has been
identified in a number of proteins with domains homologous to epidermal growth
factor (EGF).   Examples  of such  proteins  are the blood coagulation protein
factors VII, IX and X, proteins C, S, and Z, the LDL receptor, thrombomodulin,
etc.  Based on sequence comparisons  of the EGF-homology region  that contains
hydroxylated Asp or Asn, a consensus sequence  has been identified  that seems
to be required by the hydroxylase(s).

-Consensus pattern: C-x-[DN]-x(4)-[FY]-x-C-x-C
                    [D or N is the hydroxylation site]

-Note: this  consensus  pattern  is  located  in  the  N-terminal  of EGF-like
 domains, while  our  EGF-like    cysteine pattern signature (see the relevant
 entry <PDOC00021>) is located in the C-terminal.

-Last update: January 1989 / First entry.

[ 1] Stenflo J., Ohlin A.-K., Owens W.G., Schneider W.J.
     J. Biol. Chem. 263:21-24(1988).
{END}
""")

def test(debug_level = 0):
    test_list.test(debug_level = debug_level)

def dump(debug_level = 0):
    test_list.dump(debug_level)

def time_file():
    filename = "/home/dalke/ftps/databases/prosite/prosite.doc"
    infile = open(filename)
    support.time_file(format, infile, debug_level = 0)

if __name__ == "__main__":
    #dump()
    #time_file()
    test(debug_level = 0)
