from Martel.formats.trembl14 import *

import support

test_list = support.Storage()
add_test = test_list.add_test
add_test_lines = test_list.add_test_lines

add_test_lines("ID", ID, """\
ID   Q28835      PRELIMINARY;      PRT;    90 AA.
ID   Q29071      PRELIMINARY;      PRT;   528 AA.
""")

add_test("format", format, """\
ID   Q28835      PRELIMINARY;      PRT;    90 AA.
AC   Q28835;
DT   01-NOV-1996 (TrEMBLrel. 01, Created)
DT   01-NOV-1996 (TrEMBLrel. 01, Last sequence update)
DT   01-NOV-1996 (TrEMBLrel. 01, Last annotation update)
DE   CGMP-GATED RETINAL PHOTORECEPTOR CHANNEL (FRAGMENT).
OS   Oryctolagus cuniculus (Rabbit).
OC   Eukaryota; Metazoa; Chordata; Craniata; Vertebrata; Euteleostomi;
OC   Mammalia; Eutheria; Lagomorpha; Leporidae; Oryctolagus.
RN   [1]
RP   SEQUENCE FROM N.A.
RA   Hundal S.P., DiFrancesco D., Mangoni M., Brammar W.J., Conley E.C.;
RL   Biochem. Soc. Trans. 21:0-0(1993).
DR   EMBL; S65218; AAB27924.1; -.
FT   NON_TER       1      1
SQ   SEQUENCE   90 AA;  10981 MW;  DF6843EDBB8783C8 CRC64;
     KEKEKKKKEE TKKEKKEEEK KEVMIIDPSG NTYYNWLFCI TLPVMYNWTM IIARACFDEL
     QSDYLEYWLI CDYLSDIVYL VDMFVRTRTG
//
ID   Q29199      PRELIMINARY;      PRT;   111 AA.
AC   Q29199;
DT   01-NOV-1996 (TrEMBLrel. 01, Created)
DT   01-NOV-1996 (TrEMBLrel. 01, Last sequence update)
DT   01-JUN-2000 (TrEMBLrel. 14, Last annotation update)
DE   CLATHRIN HEAVY CHAIN (FRAGMENT).
OS   Sus scrofa (Pig).
OC   Eukaryota; Metazoa; Chordata; Craniata; Vertebrata; Euteleostomi;
OC   Mammalia; Eutheria; Cetartiodactyla; Suina; Suidae; Sus.
RN   [1]
RP   SEQUENCE FROM N.A.
RC   TISSUE=SMALL INTESTINE;
RX   MEDLINE; 96327607.
RA   Winteroe A.K., Fredholm M., Davies W.;
RT   "Evaluation and characterization of a porcine small intestine cDNA
RT   library: analysis of 839 clones.";
RL   Mamm. Genome 7:509-517(1996).
DR   EMBL; F14522; CAA23104.1; -.
DR   INTERPRO; IPR000547; -.
FT   NON_TER       1      1
FT   NON_TER     111    111
SQ   SEQUENCE   111 AA;  12717 MW;  9AD235E2F8CDE953 CRC64;
     YEFAERCNEP AVWXQLAKAQ LQKGMVKEAI DSYIKADDPS SYMEVVQAAN TSGNWEELVK
     YLQMARKKAR ESYVETELIF ALAKTNRLAE LEEFINGPNN AHIQQVGDRC Y
//
""")

def test():
    test_list.test(debug_level = 0)

def dump(debug_level = 0):
    test_list.dump(debug_level)

def time_file():
    import os
    filename = "/home/dalke/ftps/databases/trembl/release_compressed/mam.dat.Z"
    infile = os.popen("zcat " + filename)
    support.time_file(format, infile, debug_level = 0)

if __name__ == "__main__":
    #dump()
    #time_file()
    test()
